/*  Time-stamp: <2005-03-21 18:05:12 >  */
#include  "xml2note.h"


NOTE_NODE *NOTE_NODE_alloc(void)
{
  NOTE_NODE *ret;
  int i;
  int j;


  ret = calloc(1, sizeof(NOTE_NODE));

  if(ret == NULL){
    fprintf(stderr, "NOTE եɤ߹िΥݤǤޤǤ\n");
    exit(EXIT_FAILURE);
  }

  /*  #define  NO_INFO  -32768  */

  ret->ident = NO_INFO;

  ret->next = NULL;
  ret->pre = NULL;
  ret->samepre = NULL;
  ret->samenext = NULL;


  TF_negative(&(ret->on_time));
  TF_zero(&(ret->on_diff));
  TF_zero(&(ret->len));
  TF_zero(&(ret->len_diff));

  TF_negative(&(ret->pre_on_time));
  TF_zero(&(ret->pre_on_diff));
  TF_zero(&(ret->pre_len));
  TF_zero(&(ret->pre_len_diff));

  TF_negative(&(ret->xml_on_time));
  TF_zero(&(ret->org_xml_on_time));
  TF_zero(&(ret->xml_on_diff));
  TF_zero(&(ret->xml_len));
  TF_zero(&(ret->xml_len_diff));
  TF_zero(&(ret->xml_step));

  ret->xml_org_node = NULL;
  ret->to_note_node = NULL;


  for(i = 0; i < VAL_MAX; i++){
    ret->val[i] = -1.0;
    ret->pre_val[i] = -1.0;
    /*  union
      ret->val[i].u = 0;
    */
  }

  for(i = 0; i < NODE_STR_MAX; i++){
    strcpy(ret->str[i], "");
  }

  ret->stat = NO_INFO;

  /*  for gru  */
  ret->ioi = -1.0;
  ret->dur = -1.0;

  for(i = 0; i < GPR_NUM; i++){
    ret->GPR[i] = 0.0;
    ret->GPR_ON_OFF[i] = OFF;
    ret->pre_GPR[i] = 0.0;
    ret->pre_GPR_ON_OFF[i] = OFF;
  }
  ret->GPR_ON_OFF[GPR1] = -128;

  for(i = 0; i < GPR_PERSON_NUM; i++){
    for(j = 0; j < GPR_NUM; j++){
      ret->GPR_PERSON[i][j] = OFF;
      ret->pre_GPR_PERSON[i][j] = OFF;
    }
  }
  ret->boundaryn = OFF;

  ret->org_node = NULL;
  ret->copy_node = NULL;


  /*  for COPER  */
  ret->pre_pitch_diff = NO_INFO;
  ret->aft_pitch_diff = NO_INFO;
  for(i = 0; i < SIM_C; i++){
    for(j = 0; j < SIM_L; j++){
      ret->sim_val[i][j] = -32768.0;
    }
  }
  for(j = 0; j < SIM_L; j++){
    ret->sim_score[j] = -32768.0;
  }

  for(i = 0; i < 10; i++){
    ret->sim_corpus_s[i] = NULL;
    ret->sim_corpus_e[i] = NULL;
  }

  ret->on_bar_num = -1;
  ret->divi = -1;

  ret->xmlnode = NULL;

  ret->tie_start = OFF;
  ret->tie_stop = OFF;

  ret->pos.def_x = NO_INFO;
  ret->pos.def_y = NO_INFO;
  ret->pos.rel_x = NO_INFO;
  ret->pos.rel_y = NO_INFO;

  strcpy(ret->place, "");
  strcpy(ret->orient, "");

  strcpy(ret->font.family, "");
  strcpy(ret->font.style, "");
  ret->font.size = NO_INFO;
  ret->font.weight = NO_INFO;

  ret->voice = -1;
  ret->staff = 1;

  ret->notations.tied_type = NO_INFO;

  /*  slue   */
  for(i = 0; i < SLUR_NUM; i++){
    ret->notations.slur[i].type = NO_INFO;
    ret->notations.slur[i].number = NO_INFO;
    strcpy(ret->notations.slur[i].linetype, "");
    ret->notations.slur[i].pos.def_x = NO_INFO;
    ret->notations.slur[i].pos.def_y = NO_INFO;
    ret->notations.slur[i].pos.rel_x = NO_INFO;
    ret->notations.slur[i].pos.rel_y = NO_INFO;
    strcpy(ret->notations.slur[i].place, "");
    strcpy(ret->notations.slur[i].orient, "");
    ret->notations.slur[i].bz_offset = NO_INFO;
    ret->notations.slur[i].bz_offset2 = NO_INFO;
    ret->notations.slur[i].bz_x = NO_INFO;
    ret->notations.slur[i].bz_y = NO_INFO;
    ret->notations.slur[i].bz_x2 = NO_INFO;
    ret->notations.slur[i].bz_y2 = NO_INFO;
  }

  /*  Ȥꤢޤϡfinger  */
  strcpy(ret->notations.tech.name, "");
  strcpy(ret->notations.tech.place, "");
  ret->notations.tech.val = NO_INFO;

  strcpy(ret->notations.artic.name, "");
  strcpy(ret->notations.artic.place, "");
  ret->notations.artic.val = NO_INFO;

  /*  slue   */
  for(i = 0; i < GLISS_NUM; i++){
    ret->notations.gliss[i].type = NO_INFO;
    ret->notations.gliss[i].number = NO_INFO;
    strcpy(ret->notations.gliss[i].linetype, "");
    ret->notations.gliss[i].pos.def_x = NO_INFO;
    ret->notations.gliss[i].pos.def_y = NO_INFO;
    ret->notations.gliss[i].pos.rel_x = NO_INFO;
    ret->notations.gliss[i].pos.rel_y = NO_INFO;
  }


  strcpy(ret->grace.type, "");
  ret->grace.steal_time_pre = -1.0;
  ret->grace.steal_time_following = -1.0;
  ret->grace.make_time = -1.0;


  ret->draw_xs = -1.0;
  ret->draw_xe = -1.0;
  ret->draw_ys = -1.0;
  ret->draw_ye = -1.0;

  ret->draw_norm_xs = -1.0;
  ret->draw_norm_xe = -1.0;
  ret->draw_norm_ys = -1.0;
  ret->draw_norm_ye = -1.0;

  ret->draw_vel_stair_y = -1.0;


  return ret;
}


NOTE_NODE *NOTE_next_NODE_alloc(NOTE_NODE *cur)
{
  cur->next = NOTE_NODE_alloc();
  cur->next->pre = cur;
  
  return cur->next;
}


NOTE_NODE *NOTE_samenext_NODE_alloc(NOTE_NODE *cur)
{
  cur->samenext = NOTE_NODE_alloc();
  cur->samenext->samepre = cur;
  
  cur->samenext->on_time.beat = cur->on_time.beat;
  cur->samenext->on_time.real = cur->on_time.real;
  cur->samenext->on_time.meas = cur->on_time.meas;
  cur->samenext->on_time.delta = cur->on_time.delta;
  cur->samenext->on_time.q_time = cur->on_time.q_time;

  return cur->samenext;
}
