/* Time-stamp: <2005-04-11 13:57:51 >  */
#include  "4ru.h"


extern NOTE_NODE *note_bot;


GARC *calc_gpr5(GARC *gtop, NOTE_NODE *s, NOTE_NODE *e, int level)
{
  NOTE_NODE *srch= NULL;
  NOTE_NODE *srchRs = NULL;
  NOTE_NODE *srchRe = NULL;
  int on_off;
  int i;
  double gpr5_max;
  NOTE_NODE *gpr5_max_node = NULL;
  NOTE_NODE *gpr5_center = NULL;
  double Ls;
  double Rs;
  double Re;


  if( (e == NULL) || (s == NULL) ){  return gtop; }

  srchRe = e->next;
  while(1){
    if((srchRe == NULL) || (srchRe == note_bot)){
      srchRe = e;
      Re = e->on_time.beat + e->on_diff.beat + e->len.beat + e->len_diff.beat;
      break;
    }else if(srchRe->ident == NOTE){
      Re = srchRe->on_time.beat + srchRe->on_diff.beat;
      break;
    }
    srchRe = srchRe->next;
  }

  Ls = s->on_time.beat + s->on_diff.beat;

  gtop->s = s;
  gtop->e = e;
/*   gtop->len.beat = ((srchRe->on_time.beat + srchRe->on_diff.beat + srchRe->len.beat + srchRe->len_diff.beat) - */
/* 		    (s->on_time.beat + s->on_diff.beat) ); */
  gtop->len.beat = Re - Ls;

  if(s == e){
/*       (gtop->len.beat < 0.50) */
    free(gtop);
    gtop = NULL;
    return  NULL;
  }

/*   printf("Start ======\n"); */
/*   print_node(s); */
/*   print_node(e); */
/*   printf("len: %5.3f\n", gtop->len.beat); */

  /*====== GPR5 ͤ׻ ====== */
  gpr5_max = -32768.0;
  gpr5_max_node = NULL;
  gpr5_center = NULL;
  srch = s;
  while(1){
    if((srch == e) || (srch == NULL) || (srch == note_bot)){  break; }
    if(srch->ident == NOTE){
      on_off = OFF;
      for(i = GPR2a; i <= GPR3d; i++){
	if(srch->GPR_ON_OFF[i] == ON){
	  on_off = ON;
	  break;  /*  koko GPR2, 3 ٤ƥåƷФƤ⤤⤷ʤ  */
	}
      }

      if(on_off == ON){
	/*   NOTE Ρɤõ
	    srch:    NOTE Ρ
	    srchRs: θ NOTE Ρ  */
	srchRs = srch->next;
	while(1){
	  if(srchRs == NULL){  /*  ñ٥ȥ롼ס  */
	    printf("single\n");
	    break;
/* 	    return gtop; */
	  }
	  if( (srchRs == e) || (srchRs == note_bot) ){  /*  ¦롼פñ٥ȥ롼ס  */
	    break;
/* 	    return gtop; */
	  }
	  if(srchRs->ident == NOTE){  /*  ȯ  */
	    Rs = srchRs->on_time.beat + srchRs->on_diff.beat;
	    srch->GPR[GPR5] = normal_dist((Re - Ls) / 2.0, 1.0, Rs - Ls);
	    srch->GPR_ON_OFF[GPR5] = OFF;
/* 	    print_node(srch); */
/* 	    print_node(srchRs); */
/* 	    br_printf(-1, "Ĥδ֤ϡ%5.3f\n", srch->GPR[GPR5]); */
	    break;
	  }
	  srchRs = srchRs->next;  /*  ǤʤȤϡ¦롼פκüõ  */
	}
	if(srch->org_node != NULL){
	  srch->org_node->GPR[GPR5] = srch->GPR[GPR5];
	  srch->org_node->GPR_ON_OFF[GPR5] = srch->GPR_ON_OFF[GPR5];
	}
	if(srch->GPR[GPR5] > gpr5_max){
	  gpr5_max = srch->GPR[GPR5];
	  gpr5_max_node = srch;
/* 	  print_node(gpr5_max_node); */
	}
      }else{
	srch->GPR[GPR5] = -32768.0;
	srch->GPR_ON_OFF[GPR5] = OFF;
      }
    }
    srch = srch->next;
  }

  if( (gpr5_max_node == NULL) || (gpr5_max_node == s) || (gpr5_max_node == e) || (gpr5_max_node == note_bot) ){
    return gtop;
  }


  if(gpr5_max > 0.0){
/*     print_node(gpr5_max_node); */
/*     printf("GPR5: %5.3f\n", gpr5_max_node->GPR[GPR5]); */

    gpr5_max_node->GPR_ON_OFF[GPR5] = ON;
    if(gpr5_max_node->org_node != NULL){
      gpr5_max_node->org_node->GPR_ON_OFF[GPR5] = ON;
    }
    gtop->child[0] = garc_alloc();
    if(calc_gpr5(gtop->child[0], gtop->s, gpr5_max_node, level+1) == NULL){
      return gtop;
    }

    srch = gpr5_max_node->next;
    while(1){
      if( (srch == e) || (srch == NULL) || (srch == note_bot) ){
	free(gtop->child[0]);
	gtop->child[0] = NULL;
	return gtop;
      }
      if(srch->ident == NOTE){  break; }
      srch = srch->next;
    }
    gtop->child[1] = garc_alloc();
    if(calc_gpr5(gtop->child[1], srch, gtop->e, level+1) == NULL){
      free(gtop->child[0]);
      gtop->child[0] = NULL;
      return gtop;
    }

    if( (gtop->child[0] == NULL) || (gtop->child[1] == NULL) ){
      free(gtop);
      gtop = NULL;
      return NULL;
    }
  }

  return  gtop;
}
