#include  "disp_errline.h"

#ifndef STR_LEN
#define STR_LEN  1024
#endif


int disp_errline(char *filename, int line_no, char *linebuf, int idx, char *mesg)
{
  int i;
  char gage[STR_LEN];



  for(i = 0; i < idx; i++){
    if(*(linebuf + i) == '\t'){
      gage[i] = '\t';
    }else{
      gage[i] = ' ';
    }
  }
  gage[i] = '\0';

  br_printf(-1, "\nFile: %s, Line %d:\n", filename, line_no);
  br_printf(-1, "%s\n", jcode_local(linebuf));
  br_printf(-1, "%s", gage);
  br_printf(6, "^");
  br_printf(-1, "܂œǂ݂܂D\n");
  br_printf(2, "%s\n", jcode_local(mesg));


  return EXIT_SUCCESS;
}
