#include  "4ru.h"
#include  "GLcolors.h"


void draw_GPR1_result(NOTE_NODE *cur, double gpr_x, int draw_color, double Ltop)
{
  static GLdouble GPR1_colors[8][4];


  if(cur->GPR_ON_OFF[GPR1] == ON){
    draw_V_line(gpr_x, 0, gpr_x, Ltop + 30, OpenGLcolors[draw_color], GTTM_LINE_WIDTH * 3);
  }else if(cur->GPR_ON_OFF[GPR1] == OFF){
    set_GLcolors_by_X11name("white smoke", GPR1_colors);
    GPR1_colors[0][A] = 0.4;
    draw_V_line(gpr_x, 0, gpr_x, Ltop + 30, GPR1_colors[0], GTTM_LINE_WIDTH * 4);
  }
}


