#include  "4ru.h"
#include  "koko.h"
#include  "GLcolors.h"
#include  "batu.xbm"
#include  "maru.xbm"


#define  CHANGE_COLOR  3
/* #define  NORMAL_COLOR  5 */
#define  NORMAL_COLOR  1
/* #define  NORMAL_COLOR  0 */

#define  YT_COLOR 4
#define  MH_COLOR 2

#define  LARGE  1

extern char gttm_line[STR_LEN];
extern int gpr_person;
extern int win_h;
extern int mouse_click;

extern int ctrl_key;
extern int shift_key;

int draw_GTTM_value(NOTE_NODE *cur, double ppqbeat, double draw_on_time_bias, double Ltop)
{
  double gpr_x = -1;
  static char str_tmp[STR_LEN];
  NOTE_NODE *gttm_cur = NULL;
  int gpr_person_idx;
  int ox;
  GLdouble Thcolors[8][4];

  static char gpr_str[GPR_NUM][NODE_STR_LEN] = {
    "1",
    "2a",
    "2b",
    "3a",
    "3b",
    "3c",
    "3d",
    "4",
    "5",
    "6",
  };

  int draw_color = -1;
  int changed = OFF;
  int i;


/*   if(cur->boundaryn != ON){ */
/*     return  EXIT_SUCCESS; */
/*   } */

/*   if(gttm_exec != ON){ */
/*     return  EXIT_SUCCESS; */
/*   } */

/*   if( (cur->ident == NOTE) && (strcmp(cur->str[1], gttm_line) != 0) ){ */
/*     return  EXIT_SUCCESS; */
/*   } */

  for(i = GPR2a; i <= GPR6; i++){
    if( (cur->GPR_ON_OFF[i] == ON)
/* 	|| (cur->GPR_ON_OFF[i] == OFF) /\*   for debug *\/ */
	|| (cur->boundaryn == ON)
	){
      if(cur->copy_node != NULL){
	gttm_cur = cur->copy_node;
      }else{
	gttm_cur = cur;
      }
      
/*       print_node(gttm_cur); */
/*       print_node(gttm_cur->next); */
      
      if(gttm_cur->next != NULL){
	gpr_x = ( ( ( (gttm_cur->on_time.beat + gttm_cur->on_diff.beat + gttm_cur->len.beat + gttm_cur->len_diff.beat) +
		      (gttm_cur->next->on_time.beat + gttm_cur->next->on_diff.beat) ) / 2.0) * ppqbeat)
	  - draw_on_time_bias;
      }else{
	gpr_x =
	  ((gttm_cur->on_time.beat + gttm_cur->on_diff.beat + gttm_cur->len.beat + gttm_cur->len_diff.beat + 0.05)
	   * ppqbeat)
	  - draw_on_time_bias;
      }

      if( (neq(gttm_cur->pre_GPR[i], 0.0)) && (gttm_cur->GPR[i] != gttm_cur->pre_GPR[i]) ){
	changed = ON;
	draw_color = CHANGE_COLOR;
      }else{
	draw_color = NORMAL_COLOR;
      }

      if((gpr_person & RAW) == RAW){
	draw_V_line(gpr_x, 0, gpr_x, Ltop + 30, OpenGLcolors[draw_color], GTTM_LINE_WIDTH);
	draw_GPR1_result(cur, gpr_x, draw_color, Ltop);
	sprintf(str_tmp, "%s: %3.2f", gpr_str[i], gttm_cur->GPR[i]);
/* 	koko_fl(-1); printf("%d, %f\n", i, gttm_cur->GPR[i]); */
#ifdef LARGE
/* 	put_str_large(gpr_x, Ltop + 4 + 34 + (i*16), 0, OpenGLcolors[draw_color], str_tmp); */
	put_str_large(gpr_x, Ltop + 4 + 16 + (i*16), 0, OpenGLcolors[draw_color], str_tmp);
#else
/* 	put_str(gpr_x, Ltop + 4 + 34 + (i*16), 0, OpenGLcolors[draw_color], str_tmp); */
	put_str(gpr_x, Ltop + 4 + 16 + (i*16), 0, OpenGLcolors[draw_color], str_tmp);
#endif
      }
    }
  }

  if(changed == ON){
    draw_color = CHANGE_COLOR;
  }else{
    draw_color = NORMAL_COLOR;
  }

  if(gpr_x != -1){
    if((gpr_person & RAW) == RAW){
      draw_V_line(gpr_x, 0, gpr_x, Ltop + 30, OpenGLcolors[draw_color], GTTM_LINE_WIDTH);
      draw_GPR1_result(cur, gpr_x, draw_color, Ltop);
    }
  }else{
/*     br_printf(5, "gpr_x: -1\n"); */
    ;
  }

  if(gttm_cur != NULL){
    if((gpr_person & YT) != 0){
      draw_color = YT_COLOR;
      gpr_person_idx = YT;
      set_GLcolors_by_X11name("green3", Thcolors);
      ox = 0;
      gpr_x -= 2;
      i = GPR2a;
      if(gttm_cur->GPR_PERSON[gpr_person_idx][i] == ON){
	ox++;
	sprintf(str_tmp, "%s: %3.2f", gpr_str[i], gttm_cur->GPR[i]);
#ifdef LARGE
	put_str_large(gpr_x, Ltop + 4 + 34 + (i*16), 0, Thcolors[0], str_tmp);
#else
	put_str(gpr_x, Ltop + 4 + 34 + (i*16), 0, Thcolors[0], str_tmp);
#endif
      }
      i = GPR2b;
      if(gttm_cur->GPR_PERSON[gpr_person_idx][i] == ON){
	ox++;
	sprintf(str_tmp, "%s: %3.2f", gpr_str[i], gttm_cur->GPR[i]);
#ifdef LARGE
	put_str_large(gpr_x, Ltop + 4 + 34 + (i*16), 0, Thcolors[0], str_tmp);
#else
	put_str(gpr_x, Ltop + 4 + 34 + (i*16), 0, Thcolors[0], str_tmp);
#endif
      }
      i = GPR3b;
      if(gttm_cur->GPR_PERSON[gpr_person_idx][i] == ON){
	ox++;
	sprintf(str_tmp, "%s: %3.2f", gpr_str[i], gttm_cur->GPR[i]);
#ifdef LARGE
	put_str_large(gpr_x, Ltop + 4 + 34 + (i*16), 0, Thcolors[0], str_tmp);
#else
	put_str(gpr_x, Ltop + 4 + 34 + (i*16), 0, Thcolors[0], str_tmp);
#endif
      }
/*       if( (gttm_cur->GPR_PERSON[gpr_person_idx][GPR2a] == ON) && */
/* 	  (gttm_cur->GPR_PERSON[gpr_person_idx][GPR2b] == ON) && */
/* 	  (gttm_cur->GPR_PERSON[gpr_person_idx][GPR3b] == ON) ){ */
      if(ox >= 2){
	draw_V_line(gpr_x, 0, gpr_x, Ltop + 30, Thcolors[0], GTTM_LINE_WIDTH + 1);
	draw_GPR1_result(cur, gpr_x, draw_color, Ltop);
	if( (ctrl_key == ON) || (shift_key == ON) ){
	  if(gttm_cur->pre_GPR_PERSON[gpr_person_idx][TH] == OFF){
	    gttm_cur->GPR_PERSON[gpr_person_idx][TH] = MOD_ON;
	  }else if(gttm_cur->pre_GPR_PERSON[gpr_person_idx][TH] == MOD_ON){
	    gttm_cur->GPR_PERSON[gpr_person_idx][TH] = MOD_ON;
	  }else if(gttm_cur->pre_GPR_PERSON[gpr_person_idx][TH] == ON){
	    gttm_cur->GPR_PERSON[gpr_person_idx][TH] = ON;
	  }else if(gttm_cur->pre_GPR_PERSON[gpr_person_idx][TH] == MOD_OFF){
	    gttm_cur->GPR_PERSON[gpr_person_idx][TH] = ON;
	  }
	}else{
	  gttm_cur->GPR_PERSON[gpr_person_idx][TH] = ON;
	}
      }else{
	if( (ctrl_key == ON) || (shift_key == ON) ){
	  if(gttm_cur->pre_GPR_PERSON[gpr_person_idx][TH] == ON){
	    gttm_cur->GPR_PERSON[gpr_person_idx][TH] = MOD_OFF;
	  }else if(gttm_cur->pre_GPR_PERSON[gpr_person_idx][TH] == MOD_OFF){
	    gttm_cur->GPR_PERSON[gpr_person_idx][TH] = MOD_OFF;
	  }else if(gttm_cur->pre_GPR_PERSON[gpr_person_idx][TH] == OFF){
	    gttm_cur->GPR_PERSON[gpr_person_idx][TH] = OFF;
	  }else if(gttm_cur->pre_GPR_PERSON[gpr_person_idx][TH] == MOD_ON){
	    gttm_cur->GPR_PERSON[gpr_person_idx][TH] = OFF;
	  }
	}else{
	  gttm_cur->GPR_PERSON[gpr_person_idx][TH] = OFF;
	}
      }

      if(gttm_cur->pre_GPR_PERSON[gpr_person_idx][TH] == MOD_ON){
/* 	put_str_huge(gpr_x - 8, Ltop + 30, 0, Thcolors[0], "O"); */
	xbm_put(gpr_x - 8, Ltop + 30, 0, maru_width, maru_height, maru_bits, Thcolors[0]);
      }else if(gttm_cur->pre_GPR_PERSON[gpr_person_idx][TH] == MOD_OFF){
/* 	put_str_huge(gpr_x - 8, Ltop + 30, 0, Thcolors[0], "X"); */
	xbm_put(gpr_x - 8, Ltop + 30, 0, batu_width, batu_height, batu_bits, Thcolors[0]);
      }
    }

    if((gpr_person & MH) != 0){
/*       printf("324\n"); */
      draw_color = MH_COLOR;
      gpr_person_idx = MH;
      set_GLcolors_by_X11name("red", Thcolors);
      ox = 0;
      gpr_x += 2;
      if((gpr_person & YT) != 0){
	gpr_x += 2;
      }
	
      i = GPR2a;
      if(gttm_cur->GPR_PERSON[gpr_person_idx][i] == ON){
	ox++;
	sprintf(str_tmp, "%s: %3.2f", gpr_str[i], gttm_cur->GPR[i]);
#ifdef LARGE
	put_str_large(gpr_x, Ltop + 4 + 34 + (i*16), 0, OpenGLcolors[draw_color], str_tmp);
#else
	put_str(gpr_x, Ltop + 4 + 34 + (i*16), 0, OpenGLcolors[draw_color], str_tmp);
#endif
      }
      i = GPR2b;
      if(gttm_cur->GPR_PERSON[gpr_person_idx][i] == ON){
	ox++;
	sprintf(str_tmp, "%s: %3.2f", gpr_str[i], gttm_cur->GPR[i]);
#ifdef LARGE
	put_str_large(gpr_x, Ltop + 4 + 34 + (i*16), 0, OpenGLcolors[draw_color], str_tmp);
#else
	put_str(gpr_x, Ltop + 4 + 34 + (i*16), 0, OpenGLcolors[draw_color], str_tmp);
#endif
      }
      i = GPR3b;
      if(gttm_cur->GPR_PERSON[gpr_person_idx][i] == ON){
	ox++;
	sprintf(str_tmp, "%s: %3.2f", gpr_str[i], gttm_cur->GPR[i]);
#ifdef LARGE
	put_str_large(gpr_x, Ltop + 4 + 34 + (i*16), 0, OpenGLcolors[draw_color], str_tmp);
#else
	put_str(gpr_x, Ltop + 4 + 34 + (i*16), 0, OpenGLcolors[draw_color], str_tmp);
#endif
      }
/*       if( (gttm_cur->GPR_PERSON[gpr_person_idx][GPR2a] == ON) && */
/* 	  (gttm_cur->GPR_PERSON[gpr_person_idx][GPR2b] == ON) && */
/* 	  (gttm_cur->GPR_PERSON[gpr_person_idx][GPR3b] == ON) ){ */
      if(ox >= 2){
	draw_V_line(gpr_x, 0, gpr_x, Ltop + 30, Thcolors[0], GTTM_LINE_WIDTH + 1);
	draw_GPR1_result(cur, gpr_x, draw_color, Ltop);
	if( (ctrl_key == ON) || (shift_key == ON) ){
	  if(gttm_cur->pre_GPR_PERSON[gpr_person_idx][TH] == OFF){
	    gttm_cur->GPR_PERSON[gpr_person_idx][TH] = MOD_ON;
	  }else if(gttm_cur->pre_GPR_PERSON[gpr_person_idx][TH] == MOD_ON){
	    gttm_cur->GPR_PERSON[gpr_person_idx][TH] = MOD_ON;
	  }else if(gttm_cur->pre_GPR_PERSON[gpr_person_idx][TH] == ON){
	    gttm_cur->GPR_PERSON[gpr_person_idx][TH] = ON;
	  }else if(gttm_cur->pre_GPR_PERSON[gpr_person_idx][TH] == MOD_OFF){
	    gttm_cur->GPR_PERSON[gpr_person_idx][TH] = ON;
	  }
	}else{
	  gttm_cur->GPR_PERSON[gpr_person_idx][TH] = ON;
	}
      }else{
	if( (ctrl_key == ON) || (shift_key == ON) ){
	  if(gttm_cur->pre_GPR_PERSON[gpr_person_idx][TH] == ON){
	    gttm_cur->GPR_PERSON[gpr_person_idx][TH] = MOD_OFF;
	  }else if(gttm_cur->pre_GPR_PERSON[gpr_person_idx][TH] == MOD_OFF){
	    gttm_cur->GPR_PERSON[gpr_person_idx][TH] = MOD_OFF;
	  }else if(gttm_cur->pre_GPR_PERSON[gpr_person_idx][TH] == OFF){
	    gttm_cur->GPR_PERSON[gpr_person_idx][TH] = OFF;
	  }else if(gttm_cur->pre_GPR_PERSON[gpr_person_idx][TH] == MOD_ON){
	    gttm_cur->GPR_PERSON[gpr_person_idx][TH] = OFF;
	  }
	}else{
	  gttm_cur->GPR_PERSON[gpr_person_idx][TH] = OFF;
	}
      }
      
      if(gttm_cur->pre_GPR_PERSON[gpr_person_idx][TH] == MOD_ON){
/* 	put_str_huge(gpr_x - 8, Ltop + 30, 0, Thcolors[0], "O"); */
	xbm_put(gpr_x - 8, Ltop + 30, 0, maru_width, maru_height, maru_bits, Thcolors[0]);
      }else if(gttm_cur->pre_GPR_PERSON[gpr_person_idx][TH] == MOD_OFF){
/* 	put_str_huge(gpr_x - 8, Ltop + 30, 0, Thcolors[0], "X"); */
	xbm_put(gpr_x - 8, Ltop + 30, 0, batu_width, batu_height, batu_bits, Thcolors[0]);

      }
    }
  }

  return EXIT_SUCCESS;

}
