#include  "4ru.h"


void e2note(EL *e_cur, NOTE_NODE **note_cur, double tempo_usec)
{
  (*note_cur)->ident = NOTE;

  (*note_cur)->on_time.real = e_cur->abs_time;
  (*note_cur)->on_time.beat = (e_cur->abs_time * 1000.0) / tempo_usec;
  (*note_cur)->on_time.q_time = (*note_cur)->on_time.beat;

  (*note_cur)->on_diff.real = 0.0;
  (*note_cur)->on_diff.beat = 0.0;
  (*note_cur)->on_diff.q_time = 0.0;

  (*note_cur)->len.real = e_cur->dur_time;
  (*note_cur)->len.beat = (e_cur->dur_time * 1000.0) / tempo_usec;
  (*note_cur)->len.q_time = (*note_cur)->len.beat;

  (*note_cur)->len_diff.real = 0.0;
  (*note_cur)->len_diff.beat = 0.0;
  (*note_cur)->len_diff.q_time = 0.0;

  (*note_cur)->val[NOTE_NO] = e_cur->val1;
  (*note_cur)->val[ON_VEL] = e_cur->val2;
  strncpy((*note_cur)->str[0], e_cur->str, 3);

  (*note_cur)->ioi = e_cur->IOI_time;
  (*note_cur)->dur = e_cur->dur_time;

#ifdef NOTEFILE_H
  e_cur->note_node = (*note_cur);
#endif
}
