/*  Time-stamp: <2004-07-30 17:43:12 >  */
#include  "4ru.h"

xmlNode *gen_XML_sound(xmlNode **xml_meas, NOTE_HEADER *note_header_info)
{
  xmlNode *xml_cur = NULL;
  xmlNode *xml_sound = NULL;
  char str_tmp[STR_LEN];
  int qbpm;

  if(note_header_info->bpm != -1){
    xml_sound = xmlNewChild(*xml_meas, NULL, BAD_CAST "sound", NULL);
    qbpm = note_header_info->bpm * (16.0 / note_header_info->bpm_base);
    sprintf(str_tmp, "%d", qbpm);
    xmlNewProp(xml_sound, BAD_CAST "tempo", BAD_CAST str_tmp);
  }

  if(note_header_info->beattime != -1){
    xml_sound = xmlNewChild(*xml_meas, NULL, BAD_CAST "sound", NULL);
    qbpm = 60000 / (note_header_info->beattime * (16.0 / note_header_info->beattime_base));
    sprintf(str_tmp, "%d", qbpm);
    xmlNewProp(xml_sound, BAD_CAST "tempo", BAD_CAST str_tmp);
  }

  return xml_cur;

}
