/* Time-stamp: <2005-05-21 22:20:03 >  */
#include  "4ru.h"

extern GARC *gtop;
extern NOTE_NODE *note_bot;

/*
  GPR6 (Parallelism)
Where two or more segments of the music can be construed as parallel,
they preferably form  parallel parts of groups.
*/

#define  MATCH_TH 0.5


int gpr6(NOTE_NODE *linetop)
{
/*   NOTE_NODE *cur = NULL; */
/*   NOTE_NODE *srch = NULL; */
  int person;
  NOTE_NODE *bci = NULL;
  NOTE_NODE *bcj = NULL;
  int r;
  double xir;
  double xi_r;
  double xjr;
  double yijr;
  double zijr;
  int i_top;
  int j_top;
  int i_found;
  int j_found;
  double G_start;
  double Wr;
  double Ws;
  double Wl;



  Wr = 0.5;
  Wl = 1.0;
  Ws = 0.5;


  bci = linetop;
  person = -1;
  i_top = OFF;
  j_top = OFF;

  r = 2;

  xir = 0.0;
  xjr = 0.0;
  yijr = 0.0;
  zijr = 0.0;

/*   notelist_display(bci); */
/*   exit(0); */

  while(1){
    if((bci == NULL) || (bci == note_bot)){
      return  EXIT_SUCCESS;
    }
    if(bci->ident == NOTE){
      if(bci->pre != NULL){
	bci = bci->pre;
	i_top = ON;
      }
      break;
    }
    bci = bci->next;
  }


  /*  i ̃[v  */
  i_found = OFF;
  while(1){
    if((bci == NULL) || (bci == note_bot)){
      break;
    }
    if(i_top == ON){  /*  ȓ́CŎg  */
      xir = gpr6_X(bci, r, person);
      xi_r = 0.0;
      i_found = ON;
    }else if(chk_gpr_bc(bci, person) == ON){
      xir = gpr6_X(bci->next, r, person);
      xi_r = gpr6_X(bci, -r, person);
      i_found = ON;
    }else if(chk_last_note(bci) == ON){
      xir = 0.0;
      xi_r = gpr6_X(bci, -r, person);
      i_found = ON;
    }

    G_start = 0.0;

    if(i_found == ON){
      i_found = OFF;
/*       bcj = bci; */
/* /\*       j_top = ON; *\/ */
/*       j_top = i_top; */

      /*  j ȓɐݒ肷  */

      bcj = linetop;
      j_top = OFF;
      while(1){
	if((bcj == NULL) || (bcj == note_bot)){
	  break;
	}
	if(bcj->ident == NOTE){
	  if(bcj->pre != NULL){
	    bcj = bcj->pre;
	    j_top = ON;
	  }
	  break;
	}
	bcj = bcj->next;
      }


      /*  j ̃[v  */
      j_found = OFF;
      while(1){
	if((bcj == NULL) || (bcj == note_bot)){
	  break;
	}
	if(j_top == ON){ /*  ȓ́CŎg  */
	  j_found = ON;
	  j_top = OFF;
	  if(i_top == ON){
	    i_top = OFF;
	    xjr  = gpr6_X(bcj, r, person);
	    yijr = gpr6_Y(bci, bcj, r, person, MATCH_TH);
	    zijr = gpr6_Z(bci, bcj, r, person, MATCH_TH);
	  }else{
	    xjr  = gpr6_X(bcj, r, person);
	    yijr = gpr6_Y(bci->next, bcj, r, person, MATCH_TH);
	    zijr = gpr6_Z(bci->next, bcj, r, person, MATCH_TH);
	  }
	}else if(chk_gpr_bc(bcj, person) == ON){
	  j_found = ON;
	  if(i_top == ON){
	    i_top = OFF;
	    xjr  = gpr6_X(bcj->next, r, person);
	    yijr = gpr6_Y(bci, bcj->next, r, person, MATCH_TH);
	    zijr = gpr6_Z(bci, bcj->next, r, person, MATCH_TH);
	  }else{
	    xjr  = gpr6_X(bcj->next, r, person);
	    yijr = gpr6_Y(bci->next, bcj->next, r, person, MATCH_TH);
	    zijr = gpr6_Z(bci->next, bcj->next, r, person, MATCH_TH);
	  }
	}

	if(j_found == ON){
	  j_found = OFF;

	  G_start += (
		      ( (yijr / (xir + xjr)) * Wr * pow(r, Wl) )  +
		      ( (zijr / (xir + xjr)) * (1-Wr) * pow(r, Wl) ) );
/* 	  koko_fl(-1); printf("G_start: %5.3f\n", G_start); */
	}
	bcj = bcj->next;
      }  /*  j ̃[vI[  */
/*       koko_fl(-1); printf("G_start: %5.3f\n", G_start); */
      bci->GPR[GPR6] = G_start;
      bci->GPR_ON_OFF[GPR6] = ON;
      if(bci->org_node != NULL){
	bci->org_node->GPR[GPR6] = bci->GPR[GPR6];
	bci->org_node->GPR_ON_OFF[GPR6] = bci->GPR_ON_OFF[GPR6];
      }
      if(bci->copy_node != NULL){
	bci->copy_node->GPR[GPR6] = bci->GPR[GPR6];
	bci->copy_node->GPR_ON_OFF[GPR6] = bci->GPR_ON_OFF[GPR6];
      }
    }

    bci = bci->next;
  }  /*  i ̃[vI[  */


#if 0
/*   printf("GPR6: %d\n", GPR6); */
  bci = linetop;
  while(1){
    if(bci == NULL){  break; }
    if(bci->GPR_ON_OFF[GPR6] == ON){
/*       printf("%5.3f\n", bci->GPR[GPR6]); */
    }
    bci = bci->next;
  }
#endif

  return  EXIT_SUCCESS;
}
