/*  Time-stamp: <2004-05-27 18:48:41 >  */
#include  "NOTEfile.h"
#include  "disp_errline.h"


int note_MIDI_parse(FILE *fp, char *filename,
		     int line, char linebuf[], int *idx, char token[],
		     NOTE_HEADER *header_info, NOTE_NODE *cur)
{
  int num;
  int databuf[1024];
  int i;


  header_info = header_info;

  cur->ident = MIDI;

  num = 0;
  while(1){
    get_token(linebuf, idx, token);  /*  ʸɤФ  */
    if(stricmp(token, " ") == 0){
      get_token(linebuf, idx, token);
      if(sscanf(token, "%x", &(databuf[num])) != 1){
	if(stricmp(token, "%") == 0){  /*  ³  */
	  break;
	}else if(stricmp(token, "") == 0){  /*    */
	  break;
	}
      }
      num++;
    }else if(stricmp(token, "%") == 0){
      break;
    }else if(stricmp(token, "") == 0){
      break;
    }else{
      disp_errline(filename, line, linebuf, *idx, "ʸ󤬤롥");
      fclose(fp);
      exit(EXIT_FAILURE);
      break;
    }
  }

  cur->midi = (int *)malloc(sizeof(int) * (num - 1));
  if(cur->midi == NULL){
    br_printf(2, "%s: %d: ݤǤޤǤ\n",
		__FILE__, __LINE__);
    disp_errline(filename, line, linebuf, *idx, "");
    fclose(fp);
    exit(EXIT_FAILURE);
  }

  cur->val[0] = num;
  for(i = 0; i < num; i++){
    *(cur->midi + i) = databuf[i];
  }

  /*
  br_printf(4, "\nMIDI: ");
  for(i = 0; i < num; i++){
    br_printf(6, "%02X ", *(cur->midi + i));
  }
  br_printf(-1, "\n");
  */

  return EXIT_SUCCESS;
}
