#include  "NOTEfile.h"
#include  "disp_errline.h"


int note_beat_parse(FILE *fp, char *filename,
		    int line, char linebuf[], int *idx,   char token[],
		    NOTE_HEADER *header_info, NOTE_NODE *cur)
{
  int inttmp;


  get_token(linebuf, idx, token);  /*  ʸɤФ  */
  get_token(linebuf, idx, token);
  sscanf(token, "%d", &inttmp);
  if(header_info != NULL){
    header_info->beat_bunsi = inttmp;
  }
  if(cur != NULL){
    cur->val[0] = inttmp;
    cur->ident = BEAT;
  }

  get_token(linebuf, idx, token);
  if(stricmp(token, " ") == 0){
    get_token(linebuf, idx, token);  /*  ʸɤФ  */
  }
  if(stricmp(token, "/") != 0){
    disp_errline(filename, line, linebuf, *idx, "BEAT ζڤ '/'۾");
    printf("%2x\n", token[0]);
    printf("%s\n", token);
    fclose(fp);
    exit(EXIT_FAILURE);
  }

  get_token(linebuf, idx, token);
  if(stricmp(token, " ") == 0){
    get_token(linebuf, idx, token);  /*  ʸɤФ  */
  }

  sscanf(token, "%d", &inttmp);
  if(header_info != NULL){
    header_info->beat_bunbo = inttmp;
  }
  if(cur != NULL){
    cur->val[1] = inttmp;
  }

  get_token(linebuf, idx, token);

  /*
  printf("\n%d / %d\n", header_info->beat_bunsi, header_info->beat_bunbo);
  */
  
  return EXIT_SUCCESS;
}
