/*  Time-stamp: <2005-02-13 12:17:20 >  */
#include  "4ru.h"
#include  <glut.h>

extern int event_grab;

void srch_chk(int srch_x, int srch_y, int region_y, NOTE_NODE **srch_cur,
	      NOTE_NODE *cur, GLdouble event[8][3], double Vel_val_top, double Vel_val_bot)
{
  int event_s_x;
  int event_e_x;
  int event_s_y;
  int event_e_y;


  event_s_x = event[0][X];
  event_s_y = event[0][Y];
  event_e_x = event[2][X];
  event_e_y = event[2][Y];


  if(*srch_cur != NULL){
    return;
  }


  if( ( ((event_s_y - region_y) <= srch_y) && (srch_y <= (event_e_y + region_y)) ) ){  /*  Y ɸΤۤ  */
    if( (event_s_x <= srch_x) && (srch_x <= (((event_s_x + event_e_x) / 2.0))) ){
      event_grab = ON_DIFF_GRAB;
      *srch_cur = cur;
    }else if( ((((event_s_x + event_e_x) / 2.0)) < srch_x) && (srch_x <= event_e_x) ){
      event_grab = LEN_DIFF_GRAB;
      *srch_cur = cur;
    }
  }else if( ((Vel_val_top - (region_y * 2)) <= srch_y) && (srch_y <= (Vel_val_top + (region_y * 2))) ){
    /* Y ɸʥդΤ */
    if( (event_s_x <= srch_x) && (srch_x <= event_e_x) ){
      event_grab = ON_VEL_GRAB;
      *srch_cur = cur;
    }
  }else if( ((Vel_val_bot - (region_y * 2)) <= srch_y) && (srch_y <= (Vel_val_bot + (region_y * 2))) ){
    /* Y ɸʥդ Off-Vel  */
    if( ((event_e_x - (region_y * 2)) <= srch_x) && (srch_x <= (event_e_x + (region_y * 2))) ){
      event_grab = OFF_VEL_GRAB;
      *srch_cur = cur;
    }
  }
}
