/*  Time-stamp: <2005-05-19 09:13:36 >  */
#include  "midi_io.h"
#include  "4ru.h"
#include  "date.h"
#include  "sequence.h"


#define  OPT 1
#define  TITLE_STR 2

/* int win_w = DEFAULT_WIN_WIDTH; */
int win_w = 1280;
int win_h = DEFAULT_WIN_HEIGHT;
double camera_x = DEFAULT_CAMERA_X;
double camera_y = DEFAULT_CAMERA_Y;
double camera_z = DEFAULT_CAMERA_Z;
GLuint notescreen = 1;
int click_x = -1;
int click_y = -1;
int pre_x = -1;
int pre_y = -1;
int mid_button = OFF;

NOTE_NODE *part_top[PART_NUM];
int part_num;  /*  ե˴ޤޤѡȿ  */

NOTE_HEADER note_header_info;
NOTE_NODE *note_top;  /*  part_top NOTE եѤ 1 ܤˤޤȤ᤿ȤƬΡ  */
NOTE_NODE *note_bot;
NOTE_NODE *note_cur;
NOTE_NODE *note_alc;
NOTE_HEADER note_header_info;

EL *e_top;
EL *e_bot;
EL *e_cur;
EL *e_alc;
SMF_HEADER  smf_header_info;
int midiin_port = -1;
int midiin_mode = OFF;
int midiin_called = OFF;
int midi_in_through = OFF;
int midinote_in = NOP;

NOTE_NODE *view_note_cur;
NOTE_NODE *view_note_bot;

EL *decide_dur[DECIDE_DUR_NUM];

/* double ppqbeat = 100; */
/* double ppqbeat = 70; */
/* double ppqbeat = 19; */
/* double ppqbeat = 200; */
double ppqbeat = 25;
/* double ppqbeat = 95; */
/* double alpha = 1.0; */
double alpha = 0.3;

int view_devi = ON;
int view_score = OFF;
int disp_vel = ON;
int loud_slope = OFF;
int note_head = OFF;
int disp_event = ON;
PERF_CTRL pctrl;
int menu_id = -1;
GLdouble gosen_colors[8][4];
int srch_x;
int srch_y;
NOTE_NODE *srch_cur;
int region_x;
int region_y;

char view_filename[STR_LEN];
WRITE_CTRL wctrl;
int view;
int midiout_port;

int win_id;
int help_win = OFF;

xmlDoc *gpr_doc_top = NULL;
xmlNode *gpr_top = NULL;
int gpr_view = OFF;
int gpr_v_line = ON;

xmlDoc *xml_doc_top = NULL;


char gttm_line[STR_LEN];
int gttm_exec = OFF;

int RTgpr_mode = OFF;
int should_re_draw = OFF;

double Lbot;
double inter;
double Velbot;
double Veltop;

double draw_on_time_bias;

int event_grab = OFF;
int shift_key = OFF;
int ctrl_key = OFF;

int gpr_person = 0;


char arg_file[STR_LEN];

char out_note_file[STR_LEN];
int scroll_play = OFF;

int genchan_mode = OFF;
GEN_PARA gen_para;
int gen_rule = 0;
char prog_name[STR_LEN];
char cmd_name[STR_LEN];

int all1ch = OFF;   /*  ٤ƤΥ٥Ȥ 1ch ǽϤ  */
int pp_mode = OFF;  /*  PianoPlayer ⡼(ڥ 3ch(0xb2) ǽϤ)  */

int mouse_click = OFF;

GARC *gtop = NULL;

int default_title_title = DEFAULT_TITLE_TITLE;
int arg_title_title = NO_INFO;
int default_title_performer = DEFAULT_TITLE_PERFORMER;
int arg_title_performer = NO_INFO;

/* DRUM_DEF drum_data[DRUM_KIND] = { */
DRUM_DEF drum_data[22] = {
  {"BD", 36,  2},  /*  bass drum  */
  {"BD2",35,  2}, /*  NOIKE  BD  */
  {"SD", 40,  6},  /*  snare drum  */
  {"SD2",38,  6},  /*  snare drum 2 */
  {"OH", 46, 10},  /*  open hi-hat  */
  {"CH", 42, 10},  /*  closed hi-hat */
  {"RC", 59, 10},  /*  ride cymbal   */
  {"CC", 57, 10},  /*  crash cymbal  */
  {"LT", 45,  4},  /*  low tom  */
  {"MT", 47,  7},  /*  mid tom   */
  {"HT", 50,  8},  /*  high tom  */
  {"CP", 39, 10},  /*  claps   */
  {"RS", 37, 10},  /*  rim shot  */
  {"SC", 55, 10},  /*  splash cymbal  */
  {"CY", 49, 10},  /*  NOIKE  Cymbal  */
  {"SH", 70, 10}, /*  shaker  */
  {"TB", 54, 10},  /*  tambourine  */
  {"WB", 77, 10},  /*  wood block  */
  {"LC", 64, 10},  /*  low conga  */
  {"HC", 63, 10}, /*  high conga  */
  {"CB", 56, 10},  /*  cow bell  */
  {"-D", 75,  6},  /*  other drum  */
};


int main(int argc, char *argv[])
{
  int i;
  int smf_out;
  int _4R_out;
  int note_out;
  int _arff_out;
  PART_INFO  part_info[PART_NUM];
  int opt_arg[OPT_NUM];
  int re_divi;
  int default_vel[PART_NUM];
  int ext_type;
/*   SMF_HEADER smf_header_info; */
  EL *smf_top[MAX_TRK_NUM];
  int thanks_disp;
  int saigen_flag;
  int pr_flag;
  int coper_flag;
  char corpus_dir[STR_LEN];
  char target_file[STR_LEN];
  int play;
  int outid_idx;
  int j;
  int tyou;
  int inf_tyou;
  char gpr_file[STR_LEN];
  char gttm_dir[STR_LEN];
  ARTI_DUR  arti_dur;

  int batch_mode;
  double tempo_usec;
  char add_title_str[STR_LEN];  /*  ɥȥɽʸղäʸ  */
  int title_i;


  /*  koko  */
  get_cmd_name(argv[0], cmd_name);


  if(strnicmp(cmd_name, "flower", 6) == 0){
    play = ON;
  }else if(strnicmp(cmd_name, "nov", 3) == 0){
    view = ON;
  }else if(
	   (strnicmp(cmd_name, "genchan", 7) == 0) ||
	   (strnicmp(cmd_name, "PopE", 4) == 0)
	   ){
    sprintf(prog_name, "PopE Ver. %s %s", _4RuVER, DATE);
    genchan_mode = ON;
    ppqbeat = 19;
  }else if(strnicmp(cmd_name, "igp", 3) == 0){
    view = ON;
    view_devi = OFF;
  }else{
/*     sprintf(prog_name, "4Ru Ver. %s %s", _4RuVER, DATE); */
    strcpy(prog_name, "");
  }

  strcpy(add_title_str, "");


  title();


/*   for(i = 1; i < argc; i++){ */
/*     printf("%s\n", argv[i]); */
/*   } */
  if(argc <= 1){
    if( (strnicmp(cmd_name, "genchan", 7) == 0) ||
	(strnicmp(cmd_name, "PopE", 4) == 0) ){
      usage_genchan();
    }else{
      usage(argc, argv);
    }
    exit(EXIT_SUCCESS);
  }


  /*  ѿ  */
  for(i = 0; i < PART_NUM; i++){
    part_top[i] = NULL;
    default_vel[i] = DEFAULT_VEL;
  }

  init_note_header_info(&note_header_info);
  init_smf_header_info(&smf_header_info);
  init_partinfo(part_info);
  saigen_flag = OFF;
  pr_flag = OFF;
  coper_flag = OFF;

  /*  ư  */
  /*  UNIX magazine ̺ߤ٤  */
  smf_out = OFF;
  _4R_out = OFF;
  note_out = OFF;
  _arff_out = OFF;
  thanks_disp = OFF;
  play = OFF;
  view = OFF;
  tyou = OFF;
  inf_tyou = 0;
  gttm_exec = OFF;
  batch_mode = OFF;


  outid_idx = 1;
#if 0
  midiout_port = 0;  /*  Ѳǽ MIDI ǥХƬ  */
  midiout_port = -2;  /* ˥塼  */
#endif

#ifdef OSX
    midiout_port = 0;  /* Ƭ MIDI ǥХ  */
#else
    midiout_port = -1;  /* MIDI Mapper  */
#endif

    for(i = 0; i < DECIDE_DUR_NUM; i++){
      decide_dur[i] = NULL;
    }


  init_wctrl(&wctrl);
  init_pctrl(&pctrl);
  init_arti_dur(&arti_dur);
  init_gen_para(&gen_para);


  strcpy(arg_file, "");  /*  ư˥ե뤬ꤵʤäȤ "" Τޤ  */
  strcpy(gpr_file, "");  /*  ư˥ե뤬ꤵʤäȤ "" Τޤ  */
  strcpy(out_note_file, "");  /*  ư˥ե뤬ꤵʤäȤ "" Τޤ  */

  /*======================*/
  /*  ư  */
  /*======================*/
  for(i = 1; i < argc; i++){
    opt_arg[i] = !OPT;
    if(stricmp(argv[i], "-smf") == 0){
      smf_out = ON;
      opt_arg[i] = OPT;
    }else if(stricmp(argv[i], "-4R") == 0){
      _4R_out = ON;
      opt_arg[i] = OPT;
    }else if(stricmp(argv[i], "-notebeat") == 0){
      note_out = ON;
      wctrl.out_note_format = T_BEAT;
      opt_arg[i] = OPT;
    }else if(stricmp(argv[i], "-notemeas") == 0){
      note_out = ON;
      wctrl.out_note_format = T_MEAS;
      opt_arg[i] = OPT;
      br_printf(6, "ߤޤ󡥤ޤƤޤ\n");
      exit(0);
    }else if(stricmp(argv[i], "-notereal") == 0){
      note_out = ON;
      wctrl.out_note_format = T_REAL;
      opt_arg[i] = OPT;
    }else if(stricmp(argv[i], "-arff") == 0){
      _arff_out = ON;
      opt_arg[i] = OPT;
    }else if(stricmp(argv[i], "-view") == 0){
      view = ON;
      opt_arg[i] = OPT;
    }else if(stricmp(argv[i], "-play") == 0){
      play = ON;
      opt_arg[i] = OPT;
    }else if(stricmp(argv[i], "-ow") == 0){
      wctrl.ow_chk = ON;
      opt_arg[i] = OPT;
    }else if(stricmp(argv[i], "-gm") == 0){
      pctrl.gm_init = ON;
      opt_arg[i] = OPT;
    }else if(stricmp(argv[i], "-gs") == 0){
      pctrl.gs_init = ON;
      opt_arg[i] = OPT;
    }else if(stricmp(argv[i], "-xg") == 0){
      pctrl.xg_init = ON;
      opt_arg[i] = OPT;
    }else if(stricmp(argv[i], "-outid") == 0){
      if(argc <= (i+1)){
	br_printf(2, "-outid ϡ̻һ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      strcpy(wctrl.outid[0], "");
      strcpy(wctrl.outid[outid_idx], argv[i+1]);
      opt_arg[i] = OPT;
      opt_arg[i+1] = OPT;
      i++;
      outid_idx++;
    }else if(stricmp(argv[i], "-outport") == 0){
      if(argc <= (i+1)){
	br_printf(2, "-outport ϡͻ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }

      if(sscanf(argv[i+1], "%d", &midiout_port) != 1){
	br_printf(2, "-outport ϡͻ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      opt_arg[i] = OPT;
      opt_arg[i+1] = OPT;
      i++;
    }else if(stricmp(argv[i], "-vel") == 0){
      if(argc <= (i+1)){
	br_printf(2, "-vel ϡͻ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      if(sscanf(argv[i+1], "%d", &(pctrl.arg_default_vel)) != 1){
	br_printf(2, "-vel ϡͻ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      opt_arg[i] = OPT;
      opt_arg[i+1] = OPT;
      i++;
    }else if(stricmp(argv[i], "-on_diff") == 0){
      if(argc <= (i+1)){
	br_printf(2, "-on_diff ϡͻ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      if(sscanf(argv[i+1], "%lf", &(pctrl.on_diff_ratio)) != 1){
	br_printf(2, "-on_diff ϡͻ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      opt_arg[i] = OPT;
      opt_arg[i+1] = OPT;
      i++;
    }else if(stricmp(argv[i], "-len_diff") == 0){
      if(argc <= (i+1)){
	br_printf(2, "-len_diff ϡͻ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      if(sscanf(argv[i+1], "%lf", &(pctrl.len_diff_ratio)) != 1){
	br_printf(2, "-on_diff ϡͻ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      opt_arg[i] = OPT;
      opt_arg[i+1] = OPT;
      i++;
    }else if(stricmp(argv[i], "-ig_beattime") == 0){
      pctrl.ig_beattime = ON;
      opt_arg[i] = OPT;
    }else if(stricmp(argv[i], "-ig_bpm") == 0){
      pctrl.ig_bpm = ON;
      opt_arg[i] = OPT;
    }else if(stricmp(argv[i], "-mechanical") == 0){
      pctrl.arg_default_vel = DEFAULT_VEL;
      pctrl.on_diff_ratio = 0.0;
      pctrl.len_diff_ratio = 0.0;
      pctrl.ig_beattime = ON;
      pctrl.ig_bpm = ON;
      opt_arg[i] = OPT;
    }else if(stricmp(argv[i], "-smfdivi") == 0){
      if(argc <= (i+1)){
	br_printf(2, "-smfdivi ϡͻ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      if(sscanf(argv[i+1], "%d", &(wctrl.smf_divi)) != 1){
	br_printf(2, "-smfdivi ϡͻ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      opt_arg[i] = OPT;
      opt_arg[i+1] = OPT;
      i++;
    }else if(stricmp(argv[i], "-gpr") == 0){
      if(argc <= (i+1)){
	br_printf(2, "-gpr ϡե꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      strcpy(gpr_file, argv[i+1]);
      gpr_view = ON;
      opt_arg[i] = OPT;
      opt_arg[i+1] = OPT;
      i++;
    }else if(stricmp(argv[i], "-gttm") == 0){
/*       if(argc <= (i+2)){ */
/* 	br_printf(2, "-gttm ϡǥ쥯ȥΧ꤬ɬܤǤ\n"); */
      if(argc <= (i+1)){
	br_printf(2, "-gttm ϡΧ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
/*       strcpy(gttm_dir, argv[i+1]); */
/*       strcpy(gttm_line, argv[i+2]); */
      strcpy(gttm_line, argv[i+1]);
      gttm_exec = ON;
      opt_arg[i] = OPT;
      opt_arg[i+1] = OPT;
      opt_arg[i+2] = OPT;
      i += 2;
    }else if(stricmp(argv[i], "-view_devi") == 0){
      if(argc <= (i+1)){
	br_printf(2, "-view_devi ϡon  off λ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      if(stricmp(argv[i+1], "on") == 0){
	view_devi = ON;
      }else{
	view_devi = OFF;
      }
      opt_arg[i] = OPT;
      opt_arg[i+1] = OPT;
      i++;
    }else if(stricmp(argv[i], "-outnotefile") == 0){
      if(argc <= (i+1)){
	br_printf(2, "-outnotefile ϡϥեλ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      strcpy(out_note_file, argv[i+1]);
      opt_arg[i] = OPT;
      opt_arg[i+1] = OPT;
      i++;
    }else if(stricmp(argv[i], "-saigen") == 0){
      opt_arg[i] = OPT;
      saigen_flag = ON;
    }else if(stricmp(argv[i], "-pr") == 0){
      opt_arg[i] = OPT;
      pr_flag = ON;
    }else if(stricmp(argv[i], "-coper") == 0){
      if(argc <= (i+1)){
	br_printf(2, "-coper ϡоݥեλ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
/*       strcpy(corpus_dir, "/cygdrive/f/home/noike/4ru/sonatine"); */
      strcpy(corpus_dir, "/cygdrive/c/cygwin/home/noike/4ru/sonatine");
      strcpy(target_file, argv[i+1]);
      opt_arg[i] = OPT;
      coper_flag = ON;
      view = OFF;
    }else if(stricmp(argv[i], "-noinittempo") == 0){
      pctrl.init_tempo = -1;
      opt_arg[i] = OPT;
    }else if(stricmp(argv[i], "-thanks") == 0){
      thanks_disp = ON;
      opt_arg[i] = OPT;
    }else if(stricmp(argv[i], "-tyou") == 0){
      tyou = ON;
      opt_arg[i] = OPT;
    }else if( (stricmp(argv[i], "-genchan") == 0) ||
	      (stricmp(argv[i], "-Pope") == 0) ) {
      genchan_mode = ON;
      view_devi = OFF;

      if(argc <= (i+6)){
	br_printf(2, "-genchan ϡͻ꤬ɬܤǤ\n");
	usage_genchan();
	exit(EXIT_SUCCESS);
      }
      if(sscanf(argv[i+1], "%lf", &(gen_para.g0_vel)) != 1){
	br_printf(2, "-genchan ϡͻ꤬ɬܤǤ\n");
	usage_genchan();
	exit(EXIT_SUCCESS);
      }
      if(sscanf(argv[i+2], "%lf", &(gen_para.g1_vel)) != 1){
	br_printf(2, "-genchan ϡͻ꤬ɬܤǤ\n");
	usage_genchan();
	exit(EXIT_SUCCESS);
      }
      if(sscanf(argv[i+3], "%d", &(gen_para.default_vel[0])) != 1){
	br_printf(2, "-genchan ϡͻ꤬ɬܤǤ\n");
	usage_genchan();
	exit(EXIT_SUCCESS);
      }
      if(sscanf(argv[i+4], "%d", &(gen_para.default_vel[1])) != 1){
	br_printf(2, "-genchan ϡͻ꤬ɬܤǤ\n");
	usage_genchan();
	exit(EXIT_SUCCESS);
      }
      if(sscanf(argv[i+5], "%lf", &(gen_para.ls1)) != 1){
	br_printf(2, "-genchan ϡͻ꤬ɬܤǤ\n");
	usage_genchan();
	exit(EXIT_SUCCESS);
      }
      if(sscanf(argv[i+6], "%lf", &(gen_para.ls2)) != 1){
	br_printf(2, "-genchan ϡͻ꤬ɬܤǤ\n");
	usage_genchan();
	exit(EXIT_SUCCESS);
      }
      opt_arg[i] = OPT;
      opt_arg[i+1] = OPT;
      opt_arg[i+2] = OPT;
      opt_arg[i+3] = OPT;
      opt_arg[i+4] = OPT;
      opt_arg[i+5] = OPT;
      opt_arg[i+6] = OPT;
      i+=6;
/*     }else if(stricmp(argv[i], "-batch") == 0){ */
/*       batch_mode = ON; */
/*       opt_arg[i] = OPT; */
    }else if(stricmp(argv[i], "-midiin") == 0){
      midiin_mode = ON;
      opt_arg[i] = OPT;
      gpr_person = RAW;
    }else if(stricmp(argv[i], "-gprth") == 0){
      if(argc <= (i+1)){
	br_printf(2, "-gprth ϡͤꤹʸɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      if(stricmp(argv[i+1], "raw") == 0){
	gpr_person = RAW;
      }else if(stricmp(argv[i+1], "YT") == 0){
	gpr_person = YT;
      }else if(stricmp(argv[i+1], "MH") == 0){
	gpr_person = MH;
      }else{
	br_printf(2, "%s Ȥͻʸϡ̤Ǥ\n", argv[i+1]);
	exit(EXIT_SUCCESS);
      }
      opt_arg[i] = OPT;
      opt_arg[i+1] = OPT;
      i++;
    }else if(stricmp(argv[i], "-all1ch") == 0){
      all1ch = ON;
      opt_arg[i] = OPT;
    }else if(stricmp(argv[i], "-ppmode") == 0){
      all1ch = ON;
      pp_mode = ON;
      opt_arg[i] = OPT;
    }else if(stricmp(argv[i], "-width") == 0){
      if(argc <= (i+1)){
	br_printf(2, "-width ϡͻ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      if(sscanf(argv[i+1], "%d", &win_w) != 1){
	br_printf(2, "-width ϡͻ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      opt_arg[i] = OPT;
      opt_arg[i+1] = OPT;
      i++;
    }else if(stricmp(argv[i], "-height") == 0){
      if(argc <= (i+1)){
	br_printf(2, "-height ϡͻ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      if(sscanf(argv[i+1], "%d", &win_h) != 1){
	br_printf(2, "-height ϡͻ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      opt_arg[i] = OPT;
      opt_arg[i+1] = OPT;
      i++;
    }else if(stricmp(argv[i], "-ppqbeat") == 0){
      if(argc <= (i+1)){
	br_printf(2, "-ppqbeat ϡͻ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      if(sscanf(argv[i+1], "%lf", &ppqbeat) != 1){
	br_printf(2, "-ppqbeat ϡͻ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      opt_arg[i] = OPT;
      opt_arg[i+1] = OPT;
      i++;
    }else if(stricmp(argv[i], "-displevel") == 0){
      if(argc <= (i+1)){
	br_printf(2, "-displevel ϡͻ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      if(sscanf(argv[i+1], "%d", &(pctrl.displevel)) != 1){
	br_printf(2, "-displevel ϡͻ꤬ɬܤǤ\n");
	exit(EXIT_SUCCESS);
      }
      opt_arg[i] = OPT;
      opt_arg[i+1] = OPT;
      i++;
    }else if(stricmp(argv[i], "-title") == 0){
      arg_title_title = ON;
      opt_arg[i] = TITLE_STR;
    }else if(stricmp(argv[i], "-title-") == 0){
      arg_title_title = OFF;
      opt_arg[i] = TITLE_STR;
    }else if(stricmp(argv[i], "-performer") == 0){
      arg_title_performer = ON;
      opt_arg[i] = TITLE_STR;
    }else if(stricmp(argv[i], "-performer-") == 0){
      arg_title_performer = OFF;
      opt_arg[i] = TITLE_STR;
    }else if(argv[i][0] == '-'){
      br_printf(2, "%s: %d: %s ȤץϤޤ\n", __FILE__, __LINE__, argv[i]);
      exit(EXIT_FAILURE);
    }
  }
  /*  ޤǵưץ  */

  for(i = 0; i < PART_NUM; i++){
    default_vel[i] = gen_para.default_vel[i];
  }
  /*  ǥեưϡviewer  */
  if( (smf_out == OFF) &&
      (_4R_out == OFF) &&
      (note_out == OFF) &&
      (_arff_out == OFF) &&
      (play == OFF) &&
      (coper_flag == OFF) &&
/*       (genchan_mode == OFF) && */
      (view == OFF)
/*       && */
/*       (batch_mode == OFF) */
      ){
    view = ON;
    genchan_mode = OFF;
  }

  if(midiin_mode == ON){
/*     br_printf(4, "\n select MIDI out port\n"); */
/*     if(open_midi_out(select_midi_out()) == EXIT_FAILURE){ */
    if(open_midi_out(0) == EXIT_FAILURE){
      midi_exit(0);
      exit(0);
    }
    br_printf(5, "\n select MIDI in port\n");
    if(open_midi_in(select_midi_in()) == EXIT_FAILURE){
/*     if(open_midi_in(0) == EXIT_FAILURE){ */
      midi_exit(0);
      exit(0);
    }
    midi_in_through = ON;
    tempo_usec = 500000;
    set_tempo_usec(tempo_usec);
  }

  for(i = 1; i < argc; i++){
    if( (opt_arg[i] == !OPT) && (opt_arg[i] != TITLE_STR) ) {
      if(exist_chk(argv[i]) == EXIST){
	strcpy(arg_file, argv[i]);
      }
      switch(ext_type = ext_chk(arg_file)){
      case  EXT_XML:  /*  XML ɤ߹  */
	br_printf(8, "%s", arg_file);
	br_printf(-1," Reading... ");
	/*  XML ɤ߹ߤʤ顤NOTE ꥹȤ  */
	xml_read(arg_file, part_top, part_info, &part_num, &xml_doc_top, &note_header_info, "4Ru",
		 &re_divi, default_vel, &arti_dur, drum_data);
	note_header_info.timescale = T_BEAT;

	for(j = 0; j < PART_NUM; j++){
	  note_time_consistency(part_top[j], &note_header_info);
	}
	note_top = part_merge(part_top, part_num);
/* 	note_top = note_make_Ttree(note_top, &note_header_info); */

	br_printf(4, "Ok!\n");
	break;


      case  EXT_SMF:
	br_printf(3, "SMF can't process, yet.\n");
	continue;



      case  EXT_NOTE:  /*  NOTE ɤ߹  */
	br_printf(6, "%s", arg_file);
	br_printf(-1," Reading... ");
	note_top = NOTEfile_read(arg_file, &note_header_info, drum_data);
	note_time_consistency(note_top, &note_header_info);
	part_top[0] = note_top;
	part_num = 1;
	br_printf(4, "Ok!\n");
	break;


      default:
	br_printf(2, "%s: %d: Τ̥եĥҤǤ\n", __FILE__, __LINE__);
	continue;
      }

      strcpy(add_title_str, "");
      for(title_i = 1; title_i < argc; title_i++){
	if( (stricmp(argv[title_i], "-title") == 0) && (strcmp(note_header_info.title, "") != 0) ){
	  strcat(add_title_str, " ");
	  strcat(add_title_str, note_header_info.title);
	}else if( (stricmp(argv[title_i], "-performer") == 0) && (strcmp(note_header_info.performer, "") != 0) ){
	  strcat(add_title_str, " ");
	  strcat(add_title_str, note_header_info.performer);
	}
      }

      if( (arg_title_title == NO_INFO) && (default_title_title == ON) && (strcmp(note_header_info.title, "") != 0) ){
	strcat(add_title_str, " ");
	strcat(add_title_str, note_header_info.title);
      }
      if( (arg_title_performer == NO_INFO) && (default_title_performer == ON) && (strcmp(note_header_info.performer, "") != 0) ){
	strcat(add_title_str, " ");
	strcat(add_title_str, note_header_info.performer);
      }
	
      
      if(gttm_exec == ON){
	gttm(gttm_dir);
      }
      
      if(strcmp(gpr_file, "") != 0){
	gpr_read(gpr_file);
      }

      if(genchan_mode == ON){
	genchan();
	for(j = 0; j < PART_NUM; j++){
	  default_vel[j] = gen_para.default_vel[j];
	}
      }



      if(view == ON){
	view_note_cur = note_top;
	strcpy(view_filename, arg_file);
	nov_init(&argc, argv, arg_file, add_title_str);
      }
      
      if(saigen_flag == ON){
	saigen(arg_file, part_top, part_info, part_num, &note_header_info, &smf_header_info, wctrl, pctrl);
	note_header_info.timescale = T_BEAT;
	for(j = 0; j < PART_NUM; j++){
	  note_time_consistency(part_top[j], &note_header_info);
	}
	note_top = part_merge(part_top, part_num);
      }

      if(pr_flag == ON){
#if 0
	perf_render(arg_file, part_top, part_info, part_num, &note_header_info, &smf_header_info, wctrl, pctrl);
#else
	perf_render(arg_file, &note_top, &note_header_info, wctrl, pctrl);
#endif
      }

      if(coper_flag == ON){
	coper(corpus_dir, target_file, wctrl);
      }

      if(smf_out == ON){
	SMF_out(arg_file, part_top, part_info, part_num, &note_header_info, &smf_header_info, wctrl, pctrl, drum_data);
      }

      if(_4R_out == ON){
	_4R_file_out(arg_file, ext_type, note_top, &note_header_info, smf_header_info.divi, wctrl, xml_doc_top, drum_data);
      }

      if(note_out == ON){
	NOTEfile_write(arg_file, out_note_file, &note_header_info, note_top, wctrl);
      }

      if(_arff_out == ON){
	arff_out(arg_file, part_top, part_info, part_num, &note_header_info, wctrl, pctrl);
      }

      if(play == ON){
	sequence_play(note_header_info, note_top, smf_header_info, smf_top, midiout_port, wctrl, pctrl, drum_data);
      }

      if(tyou == ON){
	inf_tyou = tyou_infer(note_top);
	printf("\ntyou: %d: ", inf_tyou);
	if(inf_tyou > 0){
	  printf("# %d\n", inf_tyou);
	}else if(inf_tyou < 0){
	  printf("b %d\n", -inf_tyou);
	}else{
	  printf("- 0\n");
	}
      }

      if(ext_type == EXT_XML){
	xml_close(xml_doc_top);  /*  NOTE ǡꥹȤ󥯤ĥäƤΤǡ
				     ǸĤ  */
      }

      puts("\n");
    }
  }


  if(midiin_mode == ON){
    if(view == ON){
      RTgpr_mode = ON;
      gttm_exec = ON;
      RTgpr(&argc, argv, arg_file);
    }
  }


  if( (view == ON) && (strcmp(arg_file, "") == 0) ){
    /*  ǥ⡼  */
    view_note_cur = note_top;
    nov_init(&argc, argv, prog_name, add_title_str);
  }

  if(thanks_disp == ON){
    thanks();
  }

  /* ѡǼưŪ˳ݤ줿ѿ  */
  xmlCleanupParser();

  return EXIT_SUCCESS;
}
