/*  Time-stamp: <2004-12-13 14:18:36 >  */
#ifndef SMFRW_H
#define SMFRW_H

#include  <stdio.h>
#include  <stdlib.h>
#include  <math.h>
#include  <string.h>
#include  "NOTEfile.h"
#include  "disp_ctr.h"


/*  萔̒`  */
#define  MAX_TRK_NUM        32
#define  MAC_HEAD_TRY_BYTE  256
#define  SMFInfN              7   /*  SMF wb_񖼂̕\F   */
#define  SMFInfV              5   /*  SMF wb_̕\F     */
#define  DEFAULT_SMF_DIVI   480  /*  o SMF ̃ftHg̕\  */

#define  EX_DATA_LEN  256

/*
typedef enum _smfrwident{
GPR1, GPR1a, GPR2a, GPR2b, GPR3a, GPR3b, GPR3c, GPR3d, GPR4, GPR5, GPR6} SMFrwident;
*/

#define  EOT 3
#define  TEMPO 4


/*  \̂̒`  */
/*  wb_  */
typedef struct smf_header{
  int format;
  int ntrks;
  int divi;
}SMF_HEADER;


/*  Cxg  */
typedef struct el{
  struct el *pre;
  int ident;
  int stat;
  int val1;
  int val2;
  int nval1;  /*  NOTE ` val1 ̒l */
  int nval2;  /*  NOTE ` val2 ̒l */
  int abs_delta;
  double abs_time;  /*  SetTempo CxgfꂽC̃Cxg̔  */
  int rel_delta;  /*  ÕCxgC̃Cxg܂ł̑Ύ  */
  double rel_time;  /*  SetTempo CxgfꂽC̃Cxg̔  */
  int IOI_delta;  /*  delta ^CPʂł IOI  */
  double IOI_time;  /*  ԒPʂł duration  */

  int dur_delta;  /*  delta ^CPʂł duration  */
  double dur_time;  /*  ԒPʂł duration  */
  char str[128];
  char disp_str[128];
  int data[EX_DATA_LEN];
  int data_len;
  double timestamp;
  double timestamp_for_disp;
  struct el *next;
#ifdef NOTEFILE_H
  NOTE_NODE *note_node;
#endif
}EL;


/*  e|񃊃Xg  */
typedef struct _tempo_list{
  struct _tempo_list *pre;
  int abs_delta;
  double  tempo_usec;
  struct _tempo_list *next;
}TEMPO_LIST;

/*  ֐vg^Cv錾  */
/*  J֐  */
int smf_read(char *filename, EL *smf_top[MAX_TRK_NUM], SMF_HEADER *smf_header_info);
int smf_write(char *filename, SMF_HEADER *header_info, EL *top[MAX_TRK_NUM]);
int EL_free(EL *top[MAX_TRK_NUM], int ntrks);
EL *smf_trk_merge(EL *smf_top[MAX_TRK_NUM], int ntrks);
int init_smf_header_info(SMF_HEADER *header_info);
void EL_list_free(EL *top);


/*  ꉞJ֐(܂eXgĂȂ)  */
/*  Note-On  Note-Off ̑΂TāCo duration ߂֐  */
/*
int set_dur_time(EL *top[], int trk_num);
*/
int set_IOI_dur(EL *top[], int trk_num);
int on_on_chk(EL *top);


/*  J̊֐(Ŏgp֐)  */
int smf_header_read(FILE **fp, char *filename, SMF_HEADER *header_info);
EL *smf_trk_read(FILE **fp);
long smf_get_delta(FILE **fp);
EL *smf_get_event(FILE **fp);
EL *EL_alloc(void);
int init_stat_str(char stat_str[0x0f][128][128]);
int smf_put_delta(FILE **fp, int delta);
int smf_put_event(FILE **fp, EL *cur);
TEMPO_LIST *tempo_node_alloc(void);

#endif
