/*  Time-stamp: <2005-03-28 14:44:30 >  */
#include  "4ru.h"
#include  "GLcolors.h"


extern int gpr_v_line;
extern int win_h;

#define  GROUP_V_LINE_WIDTH  2

void draw_gpr_line(NOTE_NODE *s_node, NOTE_NODE *e_node, int Lbot, int level, double len)
{
  char str_tmp[STR_LEN];
  GLdouble group_colors[8][4];


  if( (s_node == NULL) || (e_node == NULL) ){
    return;
  }


  draw_H_line(s_node->draw_xs, Lbot - GPR_LINE_BIAS + (level * GPR_LINE_INTER) + GPR_LINE_LR_H,
	      s_node->draw_xs + GPR_LINE_LR_W, Lbot - GPR_LINE_BIAS + (level * GPR_LINE_INTER),
		  OpenGLcolors[1], 2);

  draw_H_line(s_node->draw_xs + GPR_LINE_LR_W, Lbot - GPR_LINE_BIAS + (level * GPR_LINE_INTER),
	      e_node->draw_xe - GPR_LINE_LR_W, Lbot - GPR_LINE_BIAS + (level * GPR_LINE_INTER),
		  OpenGLcolors[1], 2);

  draw_H_line(e_node->draw_xe - GPR_LINE_LR_W, Lbot - GPR_LINE_BIAS + (level * GPR_LINE_INTER),
	      e_node->draw_xe, Lbot - GPR_LINE_BIAS + (level * GPR_LINE_INTER) + GPR_LINE_LR_H,
		  OpenGLcolors[1], 2);


  sprintf(str_tmp, "%d ", level);
/*   put_str(((e_node->draw_xe + s_node->draw_xs) / 2.0), */
/*     Lbot - GPR_LINE_BIAS + (level * GPR_LINE_INTER), */
/*     0, OpenGLcolors[1], str_tmp); */
  put_str(s_node->draw_xs + GPR_LINE_LR_W,
	  Lbot - GPR_LINE_BIAS + (level * GPR_LINE_INTER) + 2,
	  0, OpenGLcolors[1], str_tmp);

  if(len > 0.0){
    sprintf(str_tmp, "%5.2f ", len);
    put_str(s_node->draw_xs + GPR_LINE_LR_W + 20,
	    Lbot - GPR_LINE_BIAS + (level * GPR_LINE_INTER) + 2,
	    0, OpenGLcolors[1], str_tmp);
  }

  if(gpr_v_line == ON){
    set_GLcolors_by_X11name("dodger blue", group_colors);
/*     draw_V_line(s_node->draw_xs, Lbot - GPR_LINE_BIAS + (level * GPR_LINE_INTER) + GPR_LINE_LR_H, */
/* 		s_node->draw_xs, win_h, */
/* 		colors, 1); */
    draw_V_line(s_node->draw_xs, Lbot - GPR_LINE_BIAS + (level * GPR_LINE_INTER) + GPR_LINE_LR_H,
		s_node->draw_xs, s_node->draw_ys,
		group_colors[0], GROUP_V_LINE_WIDTH);
/*     draw_V_line(e_node->draw_xe, Lbot - GPR_LINE_BIAS + (level * GPR_LINE_INTER) + GPR_LINE_LR_H, */
/* 		e_node->draw_xe, win_h, */
/* 		colors, 1); */
    draw_V_line(e_node->draw_xe, Lbot - GPR_LINE_BIAS + (level * GPR_LINE_INTER) + GPR_LINE_LR_H,
		e_node->draw_xe, e_node->draw_ye,
		group_colors[0], GROUP_V_LINE_WIDTH);
  }
}
