/* Time-stamp: <2005-05-27 16:55:53 >  */
#include  "iconv_if.h"


#define  FROMBUFLEN 1024

char *iconv_if(char *src, char *to_enc, char *from_enc)
{
  iconv_t cdesc;
  static char fbuf[FROMBUFLEN];
#ifdef LINUX
  char *inbuf;
#else
  static const char *inbuf;
#endif

  static char tmpbuf[FROMBUFLEN];
  static char *outbuf;
  static size_t inleft;
  static size_t outleft;

  cdesc = iconv_open(to_enc, from_enc);

  strcpy(fbuf, src);
  if(cdesc != (iconv_t)-1){
    inbuf = NULL;
    outbuf = NULL;
    inbuf = fbuf;
    inleft = strlen(fbuf);
    strcpy(tmpbuf, "");
    outbuf = tmpbuf;
    outleft= FROMBUFLEN;
    if(iconv(cdesc, &inbuf, &inleft, &outbuf, &outleft) == (size_t)-1){
      br_printf(2, "%s: %d: %s to %s Convert error!\n", __FILE__, __LINE__, from_enc, to_enc);
      strcpy(outbuf, src);
/*       return src; */
      return NULL;
    }
    tmpbuf[FROMBUFLEN - outleft] = '\0';
    iconv_close(cdesc);
    return tmpbuf;
  }else{
/*     return src; */
    return NULL;
  }

  return src;  /*  $B$J$<$+=P$F$7$^$&%3%s%Q%$%i7Y9p$X$NBP:v(B  */

}
