/*  Time-stamp: <2005-05-11 16:53:49 >  */
#include  "midi_io.h"
#include  "4ru.h"
#include  "GLcolors.h"


/* #define NORM 0x0f00 */
#define NORM 0xf00

extern int win_w;
extern int win_h;
extern double camera_x;
extern double camera_y;
extern double camera_z;
extern double alpha;
extern int view_devi;
extern int view_score;
extern int disp_vel;
extern int loud_slope;
extern int note_head;
extern int disp_event;
extern NOTE_NODE *view_note_cur;
extern NOTE_HEADER note_header_info;

extern NOTE_NODE *note_top;
extern NOTE_NODE *note_bot;

extern char view_filename[STR_LEN];
extern PERF_CTRL pctrl;
extern WRITE_CTRL wctrl;

extern int help_win;
extern double ppqbeat;

extern int gpr_v_line;
extern int gttm_exec;
extern char gttm_line[STR_LEN];
extern int gpr_person;
extern xmlNode *gpr_top;


extern char arg_file[STR_LEN];
extern char out_note_file[STR_LEN];

extern  int scroll_play;

extern int genchan_mode;
extern int gen_rule;


void key_switcher(unsigned char key, int x, int y)
{
  Skey_switcher((int)(NORM | key), x, y);
}


void Skey_switcher(int key, int x, int y)
{
/*   double now_on_time; */
/*   double skip_beat; */
  NOTE_NODE *org_view_note_cur = NULL;
  int mod_key;
  int str_x_bias;


  /*  Warning кŬǾä뤫ʡ */
  x = x;
  y = y;

/*   re_draw();  /\*  "Scroll Play ON, OFF" ɽä  *\/ */

/*   printf("%02d:%c(%X): %04d: %04d\n", glutGetModifiers(), key, key, x, y); */
  mod_key = glutGetModifiers();

  switch(key){
  case  GLUT_KEY_LEFT:  /*   */
    switch(mod_key){
    case  GLUT_ACTIVE_CTRL:
      while(view_note_cur->pre != NULL){
	view_note_cur = view_note_cur->pre;
	if(view_note_cur->ident == BAR){
	  break;
	}
      }
      break;

    case  GLUT_ACTIVE_SHIFT:
      while(view_note_cur->pre != NULL){
	view_note_cur = view_note_cur->pre;
      }
#if 0
      while(view_note_cur->next != NULL){
	if(view_note_cur->ident == NOTE){
	  break;
	}
	view_note_cur = view_note_cur->next;
      }
#endif

      break;


    default:
      while(view_note_cur->pre != NULL){
	view_note_cur = view_note_cur->pre;
	if(view_note_cur->ident == NOTE){
	  break;
	}
      }
    }

    re_draw();
/*     glutPostRedisplay(); */
    break;


  case  GLUT_KEY_RIGHT:  /*    */
    switch(mod_key){
    case  GLUT_ACTIVE_CTRL:
      while(view_note_cur->next != NULL){
	view_note_cur = view_note_cur->next;
	if(view_note_cur->ident == BAR){
	  break;
	}
      }
      break;


    case  GLUT_ACTIVE_SHIFT:
      while(view_note_cur->next != NULL){
	view_note_cur = view_note_cur->next;
      }
      while(view_note_cur->pre != NULL){
	if(view_note_cur->ident == NOTE){
	  break;
	}
	view_note_cur = view_note_cur->pre;
      }
      break;


    default:
      while(view_note_cur->next != NULL){
	view_note_cur = view_note_cur->next;
	if(view_note_cur->ident == NOTE){
	  break;
	}
      }
    }

    re_draw();
/*     glutPostRedisplay(); */
    break;


  case  'Q' | NORM :  /*  ̤ Q   */
  case  'q' | NORM :  /*  ̤ q   */
    midi_exit(0);
    signal(SIGALRM, NULL);
    fflush(stdout);
    fflush(stderr);
    fflush(stdin);
    exit(0);


  case  'R' | NORM :  /*  ̤ R   */
  case  'r' | NORM :  /*  ̤ r   */
    re_draw();
    break;


  case  'S' | NORM :  /*  ̤ S   */
  case  's' | NORM :  /*  ̤ s   */
    if(view_score == ON){
      view_score = OFF;
      glutChangeToMenuEntry(SCOREDISP_MENU, SCOREDISP_ON_STR, SCOREDISP_MENU);
    }else{
      view_score = ON;
      glutChangeToMenuEntry(SCOREDISP_MENU, SCOREDISP_OFF_STR, SCOREDISP_MENU);
    }

    re_draw();
/*     glutPostRedisplay(); */
    break;


  case  'D' | NORM :  /*  ̤ D   */
  case  'd' | NORM :  /*  ̤ d   */
    if(view_devi == ON){
      view_devi = OFF;
      glutChangeToMenuEntry(DEVIDISP_MENU, DEVIDISP_ON_STR, DEVIDISP_MENU);
    }else{
      view_devi = ON;
      glutChangeToMenuEntry(DEVIDISP_MENU, DEVIDISP_OFF_STR, DEVIDISP_MENU);
    }

    re_draw();
/*     glutPostRedisplay(); */
    break;

  case  'V' | NORM :  /*  ̤ V   */
  case  'v' | NORM :  /*  ̤ v   */
    if(disp_vel == ON){
      disp_vel = OFF;
      glutChangeToMenuEntry(DISP_VEL_MENU, DISP_VEL_ON_STR, DISP_VEL_MENU);
    }else{
      disp_vel = ON;
      glutChangeToMenuEntry(DISP_VEL_MENU, DISP_VEL_OFF_STR, DISP_VEL_MENU);
    }

    re_draw();
    break;


  case  'H' | NORM :  /*  ̤ H   */
  case  'h' | NORM :  /*  ̤ h   */
    if(note_head == ON){
      note_head = OFF;
      glutChangeToMenuEntry(NOTE_HEAD_MENU, NOTE_HEAD_ON_STR, NOTE_HEAD_MENU);
    }else{
      note_head = ON;
      glutChangeToMenuEntry(NOTE_HEAD_MENU, NOTE_HEAD_OFF_STR, NOTE_HEAD_MENU);
    }

    re_draw();
    break;



  case  'L' | NORM :  /*  ̤ L   */
  case  'l' | NORM :  /*  ̤ l   */
    if(loud_slope == ON){
      loud_slope = OFF;
      glutChangeToMenuEntry(LOUD_MENU, LOUD_ON_STR, LOUD_MENU);
    }else{
      loud_slope = ON;
      glutChangeToMenuEntry(LOUD_MENU, LOUD_OFF_STR, LOUD_MENU);
    }

    re_draw();
    break;


  case  'J' | NORM :  /*  ̤ J   */
  case  'j' | NORM :  /*  ̤ j   */
    if(disp_event == ON){
      disp_event = OFF;
      glutChangeToMenuEntry(DISP_EVENT_MENU, DISP_EVENT_ON_STR, DISP_EVENT_MENU);
    }else{
      disp_event = ON;
      glutChangeToMenuEntry(DISP_EVENT_MENU, DISP_EVENT_OFF_STR, DISP_EVENT_MENU);
    }

    re_draw();
    break;




  case  'K' | NORM :  /*  ̤ K   */
  case  'k' | NORM :  /*  ̤ k   */
    /*   Y  + ž  */
    camera_y += 10;
    alpha = VIEW_ALPHA;
    re_draw();
/*     glutPostRedisplay(); */
    break;

  case  'U' | NORM :  /*  ̤ J   */
  case  'u' | NORM :  /*  ̤ j   */
    /*   Z  - ž  */
    camera_z -= 10;
    alpha = VIEW_ALPHA;
    re_draw();
/*     glutPostRedisplay(); */
    break;

  case  'I' | NORM :  /*  ̤ K   */
  case  'i' | NORM :  /*  ̤ k   */
    /*   Z  + ž  */
    camera_z += 10;
    alpha = VIEW_ALPHA;
    re_draw();
/*     glutPostRedisplay(); */
    break;

  case  'M' | NORM :  /*  ̤ M   */
  case  'm' | NORM :  /*  ̤ m   */
    extern_SMF_out();

    break;


  case  'P' | NORM :  /*  ̤ P   */
  case  'p' | NORM :  /*  ̤ p   */
    org_view_note_cur = view_note_cur;
    extern_sequence_play();
    view_note_cur = org_view_note_cur;
    re_draw();
    break;

  case  ',' | NORM :  /*  ̤ ,   */
    if(ppqbeat > 30){
      ppqbeat -= 10;
    }else if(ppqbeat > 0){
      ppqbeat -= 1;
    }
    re_draw();
    break;


  case  '.' | NORM :  /*  ̤ .   */
    if(ppqbeat < 30){
      ppqbeat += 1;
    }else{
      ppqbeat += 10;
    }
    re_draw();
    break;


  case  '/' | NORM :  /*  ̤ /   */
    if(gpr_v_line== ON){
      gpr_v_line = OFF;
    }else{
      gpr_v_line = ON;
    }
    re_draw();
    break;


  case  'G' | NORM :  /*  ̤ G   */
  case  'g' | NORM :  /*  ̤ g   */
    gpr_person = gpr_person | RAW;
    if(stricmp(gttm_line, "") == 0){
      strcpy(gttm_line, "m0");
    }
    if(gttm_exec == ON){
      gttm_exec = OFF;
      glutChangeToMenuEntry(GPR_MENU, GPR_ON_STR, GPR_MENU);
    }else{
      gttm_exec = ON;
      glutChangeToMenuEntry(GPR_MENU, GPR_OFF_STR, GPR_MENU);
/*       gttm(NULL); */
    }

/*     re_draw(); */
    re_draw();
    break;


  case  'N' | NORM :  /*  ̤ N   */
  case  'n' | NORM :  /*  ̤ n   */
/*     wctrl.ow_chk = ON; */
    NOTEfile_write(arg_file, out_note_file, &note_header_info, note_top, wctrl);
    break;


  case  'X' | NORM :  /*  ̤ X   */
  case  'x' | NORM :  /*  ̤ x   */
/*     wctrl.ow_chk = ON; */
/*     XML_write(arg_file, xml_top, gpr_top, note_top, &note_header_info, wctrl); */  /*  koko  */
    break;


  case  'C' | NORM :  /*  ̤ C   */
  case  'c' | NORM :  /*  ̤ c   */
    str_x_bias = 200;
    if(scroll_play == ON){
      scroll_play = OFF;
      put_str_large(((win_w / 2) - str_x_bias), (win_h / 2), 0, OpenGLcolors[1], "Scroll Play OFF");
    }else{
      scroll_play = ON;
      put_str_large(((win_w / 2) - str_x_bias), (win_h / 2), 0, OpenGLcolors[1], "Scroll Play ON!");
    }
    glutSwapBuffers();

    break;


  case  'T' | NORM :  /*  ̤ T   */
  case  't' | NORM :  /*  ̤ t   */
    switch(gpr_person){
    case RAW:
      gpr_person = (RAW | YT);
      break;

    case (RAW | YT):
      gpr_person = (RAW | MH);
      break;

    case (RAW | MH):
      gpr_person = (RAW | YT | MH);
      break;

    case (RAW | YT | MH):
      gpr_person = RAW;
      break;

    }
    re_draw();
    break;


  case  'E' | NORM :  /*  ̤ E   */
  case  'e' | NORM :  /*  ̤ e   */
    genchan_mode = ON;
    genchan();
    re_draw();

    break;

  case  ('1' | NORM) - 0x10 :  /*  ̤ 1   */
  case  ('2' | NORM) - 0x10 :  /*  ̤ 2   */
  case  ('3' | NORM) - 0x10 :  /*  ̤ 3   */
  case  ('4' | NORM) - 0x10 :  /*  ̤ 4   */
  case  ('5' | NORM) - 0x10 :  /*  ̤ 5   */
  case  ('6' | NORM) - 0x10 :  /*  ̤ 6   */
  case  ('7' | NORM) - 0x10 :  /*  ̤ 7   */
  case  ('8' | NORM) - 0x10 :  /*  ̤ 8   */
  case  ('9' | NORM) - 0x10 :  /*  ̤ 9   */
    key += 0x10;
    /*  ³ν  */

  case  '1' | NORM :  /*  ̤ 1   */
  case  '2' | NORM :  /*  ̤ 2   */
  case  '3' | NORM :  /*  ̤ 3   */
  case  '4' | NORM :  /*  ̤ 4   */
  case  '5' | NORM :  /*  ̤ 5   */
  case  '6' | NORM :  /*  ̤ 6   */
  case  '7' | NORM :  /*  ̤ 7   */
  case  '8' | NORM :  /*  ̤ 8   */
  case  '9' | NORM :  /*  ̤ 9   */
    gen_rule = (key - NORM) - '0';
    genchan_mode = ON;
    genchan();
    re_draw();

    break;


  case  GLUT_KEY_F2:
/*   case  GLUT_KEY_F10: */
    if((gpr_person & RAW) == RAW){
      gpr_person = (gpr_person & ~RAW);
    }else{
      gpr_person = gpr_person | RAW;
    }

    if(stricmp(gttm_line, "") == 0){
      strcpy(gttm_line, "m0");
    }
    if(gttm_exec == OFF){
      gttm_exec = ON;
      glutChangeToMenuEntry(GPR_MENU, GPR_OFF_STR, GPR_MENU);
      gttm(NULL);
      re_draw();
    }
    re_draw();
    break;


  case  GLUT_KEY_F3:
/*   case  GLUT_KEY_F11: */
    if((gpr_person & MH) == MH){
      gpr_person = (gpr_person & ~MH);
    }else{
      gpr_person = gpr_person | MH;
    }

    if(stricmp(gttm_line, "") == 0){
      strcpy(gttm_line, "m0");
    }
    if(gttm_exec == OFF){
      gttm_exec = ON;
      glutChangeToMenuEntry(GPR_MENU, GPR_OFF_STR, GPR_MENU);
      gttm(NULL);
      re_draw();
    }
    re_draw();
    break;


  case  GLUT_KEY_F4:
/*   case  GLUT_KEY_F12: */
    if((gpr_person & YT) == YT){
      gpr_person = (gpr_person & ~YT);
    }else{
      gpr_person = gpr_person | YT;
    }

    if(stricmp(gttm_line, "") == 0){
      strcpy(gttm_line, "m0");
    }
    if(gttm_exec == OFF){
      gttm_exec = ON;
      glutChangeToMenuEntry(GPR_MENU, GPR_OFF_STR, GPR_MENU);
      gttm(NULL);
      re_draw();
    }
    re_draw();
    break;



  case  GLUT_KEY_F7:
    camera_x -= 10;
    alpha = VIEW_ALPHA;
    re_draw();
/*     glutPostRedisplay(); */
    break;

  case  GLUT_KEY_F8:
    camera_x += 10;
    alpha = VIEW_ALPHA;
    re_draw();
/*     glutPostRedisplay(); */
    break;

/*   case  GLUT_KEY_DOWN:  /\*    *\/ */
  case  GLUT_KEY_F9:
    camera_y -= 10;
    alpha = VIEW_ALPHA;
    re_draw();
/*     glutPostRedisplay(); */
    break;

#if 1
/*   case  GLUT_KEY_UP:  /\*    *\/ */
  case  GLUT_KEY_F10:
    camera_y += 10;
    alpha = VIEW_ALPHA;
    re_draw();
/*     glutPostRedisplay(); */
    break;

/*   case  GLUT_KEY_PAGE_DOWN:  /\*  PageDown  *\/ */
  case  GLUT_KEY_F11:
    camera_z -= 10;
    alpha = VIEW_ALPHA;
    re_draw();
/*     glutPostRedisplay(); */
    break;

/*   case  GLUT_KEY_PAGE_UP:  /\*  PageUp  *\/ */
  case  GLUT_KEY_F12:
    camera_z += 10;
    alpha = VIEW_ALPHA;
    re_draw();
/*     glutPostRedisplay(); */
    break;
#endif

  case  GLUT_KEY_F1:
    disp_key_help();
/*     if(help_win != ON){ */
/*       open_key_help_win(); */
/*     }else{ */
/*       close_key_help_win(); */
/*     } */

    break;

  case  'A' | NORM :  /*  ̤ A   */
  case  'a' | NORM :  /*  ̤ a   */
    camera_x = DEFAULT_CAMERA_X;
    camera_y = DEFAULT_CAMERA_Y;
    camera_z = DEFAULT_CAMERA_Z;
    re_draw();

    break;

  default:
    br_printf(4, "%x, %x\n", key, mod_key);
    br_printf(4, "%x\n", '1');
    br_printf(4, "%c\n", 0x21);

    break;
  }

  set_gosen_colors();

}
