#include  "NOTEfile.h"
#include  "disp_errline.h"


int note_beattime_parse(FILE *fp, char *filename,
			int line, char linebuf[], int *idx, char token[],
			NOTE_HEADER *header_info, NOTE_NODE *cur, int hb)
{
  double doubletmp;


  fp = fp;
  filename = filename;
  line = line;


  get_token(linebuf, idx, token);  /*  ʸɤФ  */
  get_token(linebuf, idx, token);
  sscanf(token, "%lf", &doubletmp);

  if(hb == HEADER){
    if(header_info != NULL){
      header_info->beattime = doubletmp;
    }
  }

  if(cur != NULL){
    cur->val[0] = doubletmp;
    strcpy(cur->str[0], token);
    cur->ident = BEATTIME;
  }

  get_token(linebuf, idx, token);  /*  ʸɤФ  */
  get_token(linebuf, idx, token);

  if(hb == HEADER){
    if(header_info != NULL){
      header_info->beattime_base = onkastr2val(token);
/*       printf("\nbeattime %f / %d\n", header_info->beattime, header_info->beattime_base); */
    }
  }

  if(cur != NULL){
    cur->val[1] = onkastr2val(token);
    strcpy(cur->str[1], token);
  }

  get_token(linebuf, idx, token);



  return EXIT_SUCCESS;
}
