/*  Time-stamp: <2005-05-08 06:16:18 >  */
#include  "4ru.h"
#include  <glut.h>


extern int win_w;
extern int win_h;
extern double camera_x;
extern double camera_y;
extern double camera_z;
extern GLuint notescreen;

extern NOTE_HEADER note_header_info;
extern NOTE_NODE *view_note_cur;
extern double ppqbeat;
extern double alpha;
/* extern GLdouble gosen_colors[8][4]; */

extern int gttm_exec;
extern int midiin_mode;

extern char prog_name[STR_LEN];
extern DRUM_DEF drum_data[DRUM_KIND];


void re_draw(void)
{
  static int pre_win_w;
  static int pre_win_h;
  static int pre_alpha;


  glClear(GL_COLOR_BUFFER_BIT);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(0.0, (double)win_w, 0.0, (double)win_h, 0.0, (double)win_w);

  glViewport(0, 0, win_w, win_h);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(camera_x, camera_y, camera_z, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);

  if(gttm_exec == ON){
    gttm(NULL);
  }

  glDeleteLists(notescreen, 1);
  glNewList(notescreen, GL_COMPILE_AND_EXECUTE);
  glPushAttrib(GL_CURRENT_BIT);

  draw_all(note_header_info, view_note_cur, drum_data);
  pre_win_w = win_w;
  pre_win_h = win_h;
  pre_alpha = alpha;

  glPopAttrib();
  glEndList();

  glCallList(notescreen);

  glutSwapBuffers();

  return;
}
