/*  Time-stamp: <2005-04-19 18:07:42 >  */
#include  "4ru.h"
#include  <glut.h>


extern int win_w;
extern int win_h;
extern NOTE_HEADER note_header_info;
extern NOTE_NODE *view_note_cur;
extern double ppqbeat;
extern double alpha;
extern GLdouble gosen_colors[8][4];
extern double camera_x;
extern double camera_y;
extern double camera_z;
extern int srch_x;
extern int srch_y;
extern NOTE_NODE *srch_cur;
extern int region_x;
extern int region_y;

extern double Lbot;
extern double inter;
extern double Velbot;
extern double Veltop;
extern double ppqbeat;
extern double alpha;
extern double draw_on_time_bias;

extern int event_grab;
extern int shift_key;
extern int ctrl_key;
extern int mouse_click;

extern int click_x;
extern int click_y;
extern int pre_x;
extern int pre_y;
extern int mid_button;
extern DRUM_DEF drum_data[DRUM_KIND];


void search_event(int button, int state, int x, int y)
{
  static char str_tmp[STR_LEN];
  static GLdouble event_colors[8][4];
  int draw_color = 1;


/*   printf("search: (%d, %d), %d, %d\n", x, y, button, state); */

  strcpy(str_tmp, "");

/*   if(state != GLUT_DOWN){ */
/*     return; */
/*   } */

  if(button == GLUT_MIDDLE_BUTTON){
    if(state == GLUT_DOWN){
      disp_key_help();
      mid_button = ON;
      /*     open_key_help_win(); */
    }else if(state == GLUT_UP){
      mid_button = OFF;
    }
  }

  if(state == GLUT_UP){
    event_grab = OFF;
    re_draw();
    mouse_click = OFF;
    click_x = -1;
    click_y = -1;
    return;
  }else if(state == GLUT_DOWN){
    mouse_click = ON;
    click_x = x;
    click_y = y;
    pre_x = x;
    pre_y = y;
  }

  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT){
    shift_key = ON;
  }else{
    shift_key = OFF;
  }

  if(glutGetModifiers() == GLUT_ACTIVE_CTRL){
    ctrl_key = ON;
  }else{
    ctrl_key = OFF;
  }


/*   if( (shift_key == ON) || (ctrl_key == ON) ){ */
  if(shift_key == ON){
    draw_color = 3;
    set_event_colors("pink", event_colors);
  }else{
    draw_color = 1;
    set_event_colors("blue", event_colors);
  }
  srch_cur = NULL;
  srch_x = x;
  srch_y = win_h - y;
  region_x = 10;
/*   region_y = 10; */
  region_y = 2;


  re_draw();
  if(srch_cur != NULL){
    print_node(srch_cur);  /*  Jbg& y[XgpɃR\[ɂ\  */
/*     printf("GPR1: %5.3f\n", srch_cur->GPR[GPR1]); */
    draw_str_note(srch_cur, win_w, win_h, srch_x, srch_y, draw_color);
    draw_event(srch_cur, Lbot, inter, Velbot, Veltop, ppqbeat, alpha, draw_on_time_bias, event_colors, drum_data);

    glutSwapBuffers();

  }
/*   else{ */
/*     make_menu(); */
/*   } */


}
