/*  Time-stamp: <2004-10-24 16:23:50 >  */
#include  <stdio.h>
#include  <stdlib.h>
#include  <math.h>
#include  <string.h>
#include  "SMFrw.h"
#include  "disp_ctr.h"
#include  "NOTEfile.h"


void set_event_str(EL **cur)
{
/*   static int bunsi = 0; */
/*   static int bunbo = 0; */
  /*  ftHg̒͒(# n)  */
  static int sf = 0;
  static int mi = 0;
  
  int type;
  int len;
/*   int i; */
/*   int tempo_usec; */
  char buf[3];
  static char note_name[5];
  static char scale_sharp[12][3] = {
    "C",
    "C#",
    "D",
    "D#",
    "E",
    "F",
    "F#",
    "G",
    "G#",
    "A",
    "A#",
    "B" };

  static char scale_flat[12][3] = {
    "C",
    "Db",
    "D",
    "Eb",
    "E",
    "F",
    "Gb",
    "G",
    "Ab",
    "A",
    "Bb",
    "B" };

  static char stat_str[0xf + 1][128][128];


  if(strcmp(stat_str[0x9][0], "") == 0){
      init_stat_str(stat_str);
  }  

  
  switch((*cur)->stat & 0xf0){
  case  0x80:
    (*cur)->ident = NOTE;
    if(sf >= 0){
      strcpy(note_name, scale_sharp[(*cur)->val1 % 12]);
    }
    else{	
      strcpy(note_name, scale_flat[(*cur)->val1 % 12]);
    }
    
    sprintf(buf, "%d", ((*cur)->val1 / 12) - 1);
    strcat(note_name, buf);
    strcpy((*cur)->str, note_name);
    strcat((*cur)->str, " ");
    strcat((*cur)->str, stat_str[((*cur)->stat & 0xf0) >> 4][(*cur)->val1]);
    
    break;
    
    
  case  0x90:
    (*cur)->ident = NOTE;
    if(sf >= 0){
      strcpy(note_name, scale_sharp[(*cur)->val1 % 12]);
    }
    else{	
      strcpy(note_name, scale_flat[(*cur)->val1 % 12]);
    }
    
    sprintf(buf, "%d", ((*cur)->val1 / 12) - 1);
    strcat(note_name, buf);
    strcpy((*cur)->str, note_name);
    strcat((*cur)->str, " ");
    if((*cur)->val2 != 0){
      strcat((*cur)->str, stat_str[((*cur)->stat & 0xf0) >> 4][(*cur)->val1]);
    }
    
    break;
    
    
  case  0xb0:
    switch((*cur)->val1){
    case  0x40:
      (*cur)->ident = DAMPER;
      break;

    case  0x42:
      (*cur)->ident = SOSTENUTO;
      break;

    case  0x43:
      (*cur)->ident = SOFT;
      break;

    default:
      break;
    }

  case  0xa0:
  case  0xe0:
    strcpy((*cur)->str, stat_str[((*cur)->stat & 0xf0) >> 4][(*cur)->val1]);
    
    break;
    
    
  case  0xc0:
  case  0xd0:
    (*cur)->val2 = -1;
    strcpy((*cur)->str, stat_str[((*cur)->stat & 0xf0) >> 4][(*cur)->val1]);
    
    break;
    
    
  case  0xf0:
    if(((*cur)->stat == 0xf0) || ((*cur)->stat == 0xf7)){
      type = (*cur)->val1 = (*cur)->stat;
      len = (*cur)->val2;
      strcpy((*cur)->str, "Exclusive data");

/*       if(len >= EX_DATA_LEN){ */
/* 	fprintf(stderr, */
/* 		"萔 EX_DATA_LEN  %d 傫Ȓlɒ`āCăRpCĂD\n", */
/* 		EX_DATA_LEN); */
/*       } */
/*       for(i = 0; i < len; i++){ */
/* 	(*cur)->data[i] = fgetc(*fp); */
/*       } */
    }
    else if((*cur)->stat == 0xff){	  
      type = (*cur)->val1 = (*cur)->stat;
      len = (*cur)->val2;
      strcat((*cur)->str, stat_str[((*cur)->stat & 0xf0) >> 4][(*cur)->val1]);
/*       rc_printf(5, "\n%s: ", (*cur)->str); */

      if(len >= EX_DATA_LEN){
	fprintf(stderr,
		"萔 EX_DATA_LEN  %d 傫Ȓlɒ`āCăRpCĂD\n",
		EX_DATA_LEN);
      }


      switch(type){
      case  0x00:  /*  V[PXԍ  */
      case  0x01:  /*  eLXgCxg  */
      case  0x02:  /*  쌠\  */
      case  0x03:  /*  V[PX  */
      case  0x04:  /*  y햼  */
      case  0x05:  /*  ̎  */
      case  0x06:  /*  }[J[  */
	/*  ()  "Introduction", "1st Verse", "A", "B", n[T}[NȂ  */

      case  0x07:  /*  Cut Point  */
      case  0x20:  /*  MIDI Channel Prefix  */
      case  0x21:  /*  MIDI Port  */
      case  0x54:  /*  SMPTE Offset  */
	
      case  0x7f:  /*  Sequencer-Specific Meta-Event  */
/* 	for(i = 0; i < len; i++){ */
/* 	  printf("%c", ((*cur)->data[i] = fgetc(*fp))); */
/* 	} */
/* 	printf("\n"); */
	break;

	
      case  0x2f:  /*  gbN̏I  */
	printf("\n");
	break;
	
	
      case  0x51:  /*  e|ݒ  */
/* 	tempo_usec = 0; */
/* 	for(i = 0; i < len; i++){ */
/* 	  (*cur)->data[i] = fgetc(*fp); */
/* 	  tempo_usec = (tempo_usec * 256) + (*cur)->data[i]; */
/* 	} */
/* 	printf("MIDI l %d ʕbD\n", tempo_usec); */
	break;
	
	
      case  0x58:  /*  qL  */
/* 	(*cur)->data[0] = bunsi = fgetc(*fp); */
/* 	bunbo = pow(2.0, ((*cur)->data[1] = (double)fgetc(*fp) )); */
/* 	printf("\t%d  %d q,\n", bunbo, bunsi); */
/* 	printf("\t1 gm[NbN %d MIDI NbN,\n", */
/* 	       ((*cur)->data[2] = fgetc(*fp)) ); */
/* 	printf("\t24 MIDI NbNɎO\\񕪉 %d D\n", */
/* 	       ((*cur)->data[3] = fgetc(*fp)) ); */
	break;
	
	
      case  0x59:  /*    */
/* 	(*cur)->data[0] = sf = fgetc(*fp); */
	if(sf == 0){
	  printf("#, b ȂD");
	}
	else if(sf > 0){
	  printf("# %d , ", sf);
	}
	else{
	  printf("b %d , ", -sf);
	}
	
/* 	(*cur)->data[1] = mi = fgetc(*fp); */
	if(mi == 0){
	  printf("\n");
	}
	else{
	  printf("Z\n");
	}
	
	break;
	
	
      default:
	printf("̃^Cxg %X: %d ", type, len);
/* 	for(i = 0; i < len; i++){ */
/* 	  printf("%d ", ((*cur)->data[i] = fgetc(*fp))); */
/* 	} */
	puts("");
	exit(EXIT_FAILURE);
      }
    }

    break;
    
  default:
/*     br_printf(6, " MIDI Cxg %x łD\n", (*cur)->stat); */
    break;
  }

  
  return;
}


int init_stat_str(char stat_str[0x0f + 1][128][128])
{
  int i;
  
  
  for(i = 0; i < 128; i++){
    strcpy(stat_str[0x8][i], "Note-Off");
    strcpy(stat_str[0x9][i], "Note-On");
    strcpy(stat_str[0xa][i], "Polyphonic key pressure(After-Touch)");
  }
  
  strcpy(stat_str[0xb][0], "Bank Select");
  strcpy(stat_str[0xb][0 + 0x20], "Bank Select");
  strcat(stat_str[0xb][0 + 0x20], "(LSB)");
  
  strcpy(stat_str[0xb][1], "Modulation Wheel");
  strcpy(stat_str[0xb][1 + 0x20], "Modulation Wheel");
  strcat(stat_str[0xb][1 + 0x20], "(LSB)");
  
  strcpy(stat_str[0xb][2], "Breath Controller");
  strcpy(stat_str[0xb][2 + 0x20], "Breath Controller");
  strcat(stat_str[0xb][2 + 0x20], "(LSB)");
  
  strcpy(stat_str[0xb][3], "Undefined");
  strcpy(stat_str[0xb][3 + 0x20], "Undefined");
  
  strcpy(stat_str[0xb][4], "Foot Controller");
  strcpy(stat_str[0xb][4 + 0x20], "Foot Controller");
  strcat(stat_str[0xb][4 + 0x20], "(LSB)");
  
  strcpy(stat_str[0xb][5], "Portamento Time");
  strcpy(stat_str[0xb][5 + 0x20], "Portamento Time");
  strcat(stat_str[0xb][5 + 0x20], "(LSB)");
  
  strcpy(stat_str[0xb][6], "Data Entry");
  strcpy(stat_str[0xb][6 + 0x20], "Data Entry");
  strcat(stat_str[0xb][6 + 0x20], "(LSB)");
  
  strcpy(stat_str[0xb][7], "Channel Volume");
  strcpy(stat_str[0xb][7 + 0x20], "Channel Volume");
  strcat(stat_str[0xb][7 + 0x20], "(LSB)");
  
  strcpy(stat_str[0xb][8], "Balance");
  strcpy(stat_str[0xb][8 + 0x20], "Balance");
  strcat(stat_str[0xb][8 + 0x20], "(LSB)");
  
  strcpy(stat_str[0xb][9], "Undefined");
  strcpy(stat_str[0xb][9 + 0x20], "Undefined");
  
  strcpy(stat_str[0xb][0x0a], "Pan");
  strcpy(stat_str[0xb][0x0a + 0x20], "Pan");
  strcat(stat_str[0xb][0x0a + 0x20], "(LSB)");
  
  strcpy(stat_str[0xb][0x0b], "Expression Controller");
  strcpy(stat_str[0xb][0x0b + 0x20], "Expression Controller");
  strcat(stat_str[0xb][0x0b + 0x20], "(LSB)");
  
  strcpy(stat_str[0xb][0x0c], "Effect Control 1");
  strcpy(stat_str[0xb][0x0c + 0x20], "Effect Control 1");
  strcat(stat_str[0xb][0x0c + 0x20], "(LSB)");
  
  strcpy(stat_str[0xb][0x0d], "Effect Control 2");
  strcpy(stat_str[0xb][0x0d + 0x20], "Effect Control 2");
  strcat(stat_str[0xb][0x0d + 0x20], "(LSB)");
  
  strcpy(stat_str[0xb][0x0e], "Undefined");
  strcpy(stat_str[0xb][0x0e + 0x20], "Undefined");
  
  strcpy(stat_str[0xb][0x0f], "Undefined");
  strcpy(stat_str[0xb][0x0f + 0x20], "Undefined");
  
  strcpy(stat_str[0xb][0x10], "General Purpose Controller 1");
  strcpy(stat_str[0xb][0x10 + 0x20], "General Purpose Controller 1");
  strcat(stat_str[0xb][0x10 + 0x20], "(LSB)");
  
  strcpy(stat_str[0xb][0x11], "General Purpose Controller 2");
  strcpy(stat_str[0xb][0x11 + 0x20], "General Purpose Controller 2");
  strcat(stat_str[0xb][0x11 + 0x20], "(LSB)");
  
  strcpy(stat_str[0xb][0x12], "General Purpose Controller 3");
  strcpy(stat_str[0xb][0x12 + 0x20], "General Purpose Controller 3");
  strcat(stat_str[0xb][0x12 + 0x20], "(LSB)");
  
  strcpy(stat_str[0xb][0x13], "General Purpose Controller 4");
  strcpy(stat_str[0xb][0x13 + 0x20], "General Purpose Controller 4");
  strcat(stat_str[0xb][0x13 + 0x20], "(LSB)");
  
  
  for(i = 0x14; i <= 0x1f; i++){
    strcpy(stat_str[0xb][i], "Undefined");
    strcpy(stat_str[0xb][i + 0x20], "Undefined");
  }
  
  strcpy(stat_str[0xb][0x40], "Hold 1(Damper Pedal)");
  strcpy(stat_str[0xb][0x41], "Portamento Switch");
  strcpy(stat_str[0xb][0x42], "Sostenuto(Chord Hold)");
  strcpy(stat_str[0xb][0x43], "Soft Pedal");
  strcpy(stat_str[0xb][0x44], "Legato Foot Switch");
  strcpy(stat_str[0xb][0x45], "Hold 2(Freeze)");
  strcpy(stat_str[0xb][0x46], "Sound Controller 1(Sound Variation)");
  strcpy(stat_str[0xb][0x47], "Sound Controller 2(Timbre/Harmonic Intensity)");
  strcpy(stat_str[0xb][0x48], "Sound Controller 3(Release Time)");
  strcpy(stat_str[0xb][0x49], "Sound Controller 4(Attack Time)");
  strcpy(stat_str[0xb][0x4a], "Sound Controller 5(Brightness)");
  strcpy(stat_str[0xb][0x4b], "Sound Controller 6(Decay Time)");
  strcpy(stat_str[0xb][0x4c], "Sound Controller 7(Vibrato rate)");
  strcpy(stat_str[0xb][0x4d], "Sound Controller 8(Vibrato Depth)");
  strcpy(stat_str[0xb][0x4e], "Sound Controller 9(Vibrato Delay)");
  strcpy(stat_str[0xb][0x4f], "Sound Controller 10(Unsetting)");
  strcpy(stat_str[0xb][0x50], "General Purpose Controller 5");
  strcpy(stat_str[0xb][0x51], "General Purpose Controller 6");
  strcpy(stat_str[0xb][0x52], "General Purpose Controller 7");
  strcpy(stat_str[0xb][0x53], "General Purpose Controller 8");
  strcpy(stat_str[0xb][0x54], "Portamento Control");
  
  strcpy(stat_str[0xb][0x55], "Undefined");
  strcpy(stat_str[0xb][0x56], "Undefined");
  strcpy(stat_str[0xb][0x57], "Undefined");
  strcpy(stat_str[0xb][0x58], "Undefined");
  strcpy(stat_str[0xb][0x59], "Undefined");
  strcpy(stat_str[0xb][0x5a], "Undefined");
  strcpy(stat_str[0xb][0x5b], "Effect 1 Depth(Reverb Send Level)");
  strcpy(stat_str[0xb][0x5c], "Effect 2 Depth(Tremolo Depth)");
  strcpy(stat_str[0xb][0x5d], "Effect 3 Depth(Chorus Send Level)");
  strcpy(stat_str[0xb][0x5e], "Effect 4 Depth(Celeste (Detune) Depth)");
  strcpy(stat_str[0xb][0x5f], "Effect 5 Depth(Phaser Depth)");
  
  strcpy(stat_str[0xb][0x60], "Data Increment");
  strcpy(stat_str[0xb][0x61], "Data Decrement");
  strcpy(stat_str[0xb][0x62], "NRPN LSB");
  strcpy(stat_str[0xb][0x63], "NRPN MSB");
  strcpy(stat_str[0xb][0x64], "RPN LSB");
  strcpy(stat_str[0xb][0x65], "RPN MSB");
  
  for(i = 0x66; i <= 0x77; i++){
    strcpy(stat_str[0xb][i], "Undefined");
  }

  strcpy(stat_str[0xb][0x78], "All Sound Off");
  strcpy(stat_str[0xb][0x79], "Reset All Controllers");
  strcpy(stat_str[0xb][0x7a], "Local Control");
  strcpy(stat_str[0xb][0x7b], "All Notes Off");
  strcpy(stat_str[0xb][0x7c], "OMNI Off");
  strcpy(stat_str[0xb][0x7d], "OMNI On");
  strcpy(stat_str[0xb][0x7e], "MONO Mode On");
  strcpy(stat_str[0xb][0x7f], "Poly Mode On");
  
  for(i = 0; i < 128; i++){
    strcpy(stat_str[0xc][i], "Program change");
    strcpy(stat_str[0xd][i], "Channel pressure(After-Touch)");
    strcpy(stat_str[0xe][i], "Pitch bend");
  }

  
  strcpy(stat_str[0xf][0x00], "Sequence Number");
  strcpy(stat_str[0xf][0x01], "Text Event");
  strcpy(stat_str[0xf][0x02], "Copyright Notice");
  strcpy(stat_str[0xf][0x03], "Sequence/Track Name");
  strcpy(stat_str[0xf][0x04], "Instrument Name");
  strcpy(stat_str[0xf][0x05], "Lyric");
  strcpy(stat_str[0xf][0x06], "Marker");
  strcpy(stat_str[0xf][0x07], "Cue Point");
  for(i = 0x08; i <= 0x19; i++){
      strcpy(stat_str[0xf][i], "Undefined");
  }
  strcpy(stat_str[0xf][0x20], "MIDI Channel Prefix");

  strcpy(stat_str[0xf][0x21], "MIDI Port");  /*  `CꕔŎgĂ  */

  for(i = 0x22; i <= 0x2e; i++){
      strcpy(stat_str[0xf][i], "Undefined");
  }
  strcpy(stat_str[0xf][0x2f], "End Of Track");
  for(i = 0x30; i <= 0x50; i++){
      strcpy(stat_str[0xf][i], "Undefined");
  }
  strcpy(stat_str[0xf][0x51], "Set Tempo");

  for(i = 0x52; i <= 0x53; i++){
      strcpy(stat_str[0xf][i], "Undefined");
  }

  strcpy(stat_str[0xf][0x54], "SMPTE Offset");

  for(i = 0x55; i <= 0x57; i++){
      strcpy(stat_str[0xf][i], "Undefined");
  }
  strcpy(stat_str[0xf][0x58], "Time Signature");  /*  qL  */
  strcpy(stat_str[0xf][0x59], "Key Signature");   /*        */

  for(i = 0x60; i <= 0x7e; i++){
      strcpy(stat_str[0xf][i], "Undefined");
  }
  strcpy(stat_str[0xf][0x7f], "Sequencer-Specific Meta-Event");



  
  return  EXIT_SUCCESS;
}
